//=============================================================
//   Blood Drip Splat
//   Eternal Damnation
//   Silent-Scope|Tim Wambolt
//=============================================================
class EDBloodDripSplat extends Splat;

var() Texture BloodSprites[10];

const SIZE_RANGE	=	0.4;
const SIZE_START	=	0.4;

simulated function BeginPlay()
{
	local int usecount;
	local float usescale;

	Super.BeginPlay();

 	usecount = (FRand()*9);
	ProjTexture = BloodSprites[usecount];

	if(Level.Game != None
		&& Level.Game.bIsSinglePlayer)
	{
		usescale = (SIZE_RANGE*FRand() + SIZE_START);
		SetDrawScale(usescale);
	}
}

defaultproperties
{
     BloodSprites(0)=FinalBlend'bio_blood.blood1'
     BloodSprites(1)=FinalBlend'bio_blood.blood2'
     BloodSprites(2)=FinalBlend'bio_blood.blood3'
     BloodSprites(3)=FinalBlend'bio_blood.blood4'
     BloodSprites(4)=FinalBlend'bio_blood.blood5'
     BloodSprites(5)=FinalBlend'bio_blood.blood6'
     BloodSprites(6)=FinalBlend'bio_blood.blood7'
     BloodSprites(7)=FinalBlend'bio_blood.blood8'
     BloodSprites(8)=FinalBlend'bio_blood.blood9'
     BloodSprites(9)=FinalBlend'bio_blood.blood10'
     Lifetime=8.000000
     bProjectStaticMesh=False
     DrawScale=0.300000
}
