class EDBloodImpactMachineGun extends P2Emitter;


const EXIT_VEL_BLAST		   =80;
const EXIT_VEL_BLAST_RANGE_HALF=20;
const EXIT_VEL_SPLOTCH			=20;
const EXIT_VEL_SPLOTCH_RANGE_HALF=15;

///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
simulated function PostBeginPlay()
{
	Super.PostBeginPlay();
	if(Level.Game == None
		|| !FPSGameInfo(Level.Game).bIsSinglePlayer)
		SetDirection(vector(Rotation),0);
}

function SetDirection(vector Dir, float Dist)
{
	local vector usevect;

	// Becuase this direction goes to the center of the actor
	// cut the z in half because it looks a little goofy with blood shooting that high
//	Dir.z=Dir.z/2;

	usevect = EXIT_VEL_BLAST*Dir;
	Emitters[0].StartVelocityRange.X.Max = usevect.x+EXIT_VEL_BLAST_RANGE_HALF;
	Emitters[0].StartVelocityRange.X.Min = usevect.x-EXIT_VEL_BLAST_RANGE_HALF;
	Emitters[0].StartVelocityRange.Y.Max = usevect.y+EXIT_VEL_BLAST_RANGE_HALF;
	Emitters[0].StartVelocityRange.Y.Min = usevect.y-EXIT_VEL_BLAST_RANGE_HALF;
	Emitters[0].StartVelocityRange.Z.Max = usevect.z+EXIT_VEL_BLAST_RANGE_HALF;
	Emitters[0].StartVelocityRange.Z.Min = usevect.z-EXIT_VEL_BLAST_RANGE_HALF;
	usevect = EXIT_VEL_SPLOTCH*Dir;
	Emitters[1].StartVelocityRange.X.Max = usevect.x+EXIT_VEL_SPLOTCH_RANGE_HALF;
	Emitters[1].StartVelocityRange.X.Min = usevect.x-EXIT_VEL_SPLOTCH_RANGE_HALF;
	Emitters[1].StartVelocityRange.Y.Max = usevect.y+EXIT_VEL_SPLOTCH_RANGE_HALF;
	Emitters[1].StartVelocityRange.Y.Min = usevect.y-EXIT_VEL_SPLOTCH_RANGE_HALF;
	Emitters[1].StartVelocityRange.Z.Max = usevect.z+EXIT_VEL_SPLOTCH_RANGE_HALF;
	Emitters[1].StartVelocityRange.Z.Min = usevect.z-EXIT_VEL_SPLOTCH_RANGE_HALF;
}
/*
    Begin Object Class=SpriteEmitter Name=SpriteEmitter53
        MaxParticles=2
        RespawnDeadParticles=False
        StartLocationRange=(X=(Min=-20.000000,Max=20.000000),Y=(Min=-20.000000,Max=20.000000),Z=(Min=-20.000000,Max=20.000000))
        SpinParticles=True
        SpinsPerSecondRange=(X=(Max=0.100000))
        UseSizeScale=True
        UseRegularSizeScale=False
        SizeScale(0)=(RelativeSize=0.100000)
        SizeScale(1)=(RelativeTime=1.000000,RelativeSize=1.000000)
        StartSizeRange=(X=(Min=70.000000,Max=100.000000))
        InitialParticlesPerSecond=50.000000
        AutomaticInitialSpawning=False
        DrawStyle=PTDS_AlphaBlend
        Texture=Texture'nathans.Skins.smoke5'
        TextureUSubdivisions=1
        TextureVSubdivisions=4
        BlendBetweenSubdivisions=True
        LifetimeRange=(Min=0.500000,Max=0.700000)
        StartVelocityRange=(Z=(Max=25.000000))
        Name="SpriteEmitter53"
    End Object
    Emitters(1)=SpriteEmitter'SpriteEmitter53'
*/

defaultproperties
{
     Emitters(0)=SpriteEmitter'Postal2Game.SpriteEmitter52'
     Emitters(1)=SpriteEmitter'Postal2Game.SpriteEmitter17'
     Emitters(2)=SpriteEmitter'AWPawns.SpriteEmitter13'
     Emitters(3)=SpriteEmitter'AWPawns.SpriteEmitter48'
     Emitters(4)=MeshEmitter'AWPawns.MeshEmitter1'
     AutoDestroy=True
     RemoteRole=ROLE_None
}
