///////////////////////////////////////////////////////////////////////////////
// BloodMachineGunSplat.
// Blood shoots out of a guy, onto a surface, from a machine gun hit
///////////////////////////////////////////////////////////////////////////////
class EDBloodMachineGunSplat extends Splat;

const SPLAT_NUM	=	10;
var() Texture BloodSprites[SPLAT_NUM];
var float sizerange;
var float sizestart;

function BeginPlay()
{
	local int usecount;
	local float usescale;

	Super.BeginPlay();

	// pick a random texture from the ten as one to display
	usecount = Rand(ArrayCount(BloodSprites));
	ProjTexture = BloodSprites[usecount];

	// randomly pick size
	usescale = (sizerange*FRand() + sizestart);
	SetDrawScale(usescale);
}

defaultproperties
{
     BloodSprites(0)=FinalBlend'bio_blood.blood1'
     BloodSprites(1)=FinalBlend'bio_blood.blood2'
     BloodSprites(2)=FinalBlend'bio_blood.blood3'
     BloodSprites(3)=FinalBlend'bio_blood.blood4'
     BloodSprites(4)=FinalBlend'bio_blood.blood5'
     BloodSprites(5)=FinalBlend'bio_blood.blood6'
     BloodSprites(6)=FinalBlend'bio_blood.blood7'
     BloodSprites(7)=FinalBlend'bio_blood.blood8'
     BloodSprites(8)=FinalBlend'bio_blood.blood9'
     BloodSprites(9)=FinalBlend'bio_blood.blood10'
     sizerange=0.300000
     sizestart=0.300000
     Lifetime=8.000000
     bProjectStaticMesh=False
}
