///////////////////////////////////////////////////////////////////////////////
// AW7GameInfo
// By: Kamek (kamek@postalleague.com)
// For: AW7
//
// Since the AW game extends from P2GameInfoSingle and not GameSinglePlayer,
// we have to copy a bunch of crap.
//
// 7/31/07 (Kamek)
//		Added stuff for Nightmare/Fucking Hard mode.
//		Deleted one of the harder difficulties so that the two modes aren't
//		insanely hard (in terms of dude taking damage and such). They Hate Me
//		is a bit easier now as a result.
// 8/5/07 (Kamek)
//		Changed location of Vote errand to the school
///////////////////////////////////////////////////////////////////////////////
class AW7GameInfo extends AW7EarlyGameInfo;

///////////////////////////////////////////////////////////////////////////////
// Config Vars
///////////////////////////////////////////////////////////////////////////////
var globalconfig int InitVal;
var globalconfig int CornHole;
var globalconfig int UberSquire;
var globalconfig int MetoolAlloy;
var globalconfig int BustaRhymes;
var globalconfig int UnFathomable;
var globalconfig int MatrixMan;
var globalconfig int FookedUp;

var globalconfig bool bNewWeaponOrder;	// splits up Group 1 melee weapons between 1 and 2, moves Group 2 weapons to Group 3
var globalconfig bool bDrawTime;

var() localized string GameNameShort;

var localized string DifficultyNames[14];		// These used to be held in the menu files, but now it's here
												// so both the menu and the slot mgr can get to it.

///////////////////////////////////////////////////////////////////////////////
// Consts
///////////////////////////////////////////////////////////////////////////////
const INIT_1 = 150;
const INIT_2 = 120;
const INIT_3 = 3;
const INIT_PATH = "AW7Game.AW7GameInfo InitVal";

const CORN_1 = 291;
const CORN_2 = 555;
const CORN_3 = 5.11;
const CORN_PATH = "AW7Game.AW7GameInfo CornHole";

const UBER_1 = 101;
const UBER_2 = 102;
const UBER_3 = 2;
const UBER_PATH = "AW7Game.AW7GameInfo UberSquire";

const METOOL_1 = 666;
const METOOL_2 = 911;
const METOOL_3 = 3.14;
const METOOL_PATH = "AW7Game.AW7GameInfo MetoolAlloy";

const BUSTA_1 = 222;
const BUSTA_2 = 333;
const BUSTA_3 = 1.214;
const BUSTA_PATH = "AW7Game.AW7GameInfo BustaRhymes";

const FATHOM_1 = 1000;
const FATHOM_2 = 1500;
const FATHOM_3 = 0.5;
const FATHOM_PATH = "AW7Game.AW7GameInfo UnFathomable";

const MATRIX_1 = 111;
const MATRIX_2 = 222;
const MATRIX_3 = 3.03;
const MATRIX_PATH = "AW7Game.AW7GameInfo MatrixMan";

const FOOK_1 = 64;
const FOOK_2 = 128;
const FOOK_3 = 256;
const FOOK_PATH = "AW7Game.AW7GameInfo FookedUp";

const REDTURTLE_DAYNAME = "REDTURTLEDAY";

const DEFAULT_DIFFICULTY=		5.0;		// halfway between 0 and 10
const LIEBERMAN_DIFFICULTY=		0.0;		// Difficulty has people with only melee weapons at most
const HESTON_DIFFICULTY=		9.0;		// Difficulty gives everyone a weapon, even if they didn't start with one
const INSANE_O_DIFFICULTY=		10.0;		// Very hard AI, and everyone gets weapons, but they can more often
											// get rockets and what not than usual.
const THEYHATEME_DIFFICULTY=	11.0;		// Very Hard--cops don't arrest they just attack, and everyone else
											// with a gun hates you on sight.
const NIGHTMARE_DIFFICULTY=		12.0;		// Nightmare Mode. Everyone gets a gun (like in Hestonworld) and hates your
											// guts. Cannot stock any health items except for crack. Plus, saving is
											// only allowed once per level!
const FUCKING_HARD_DIFFICULTY=	13.0;		// Insane-O + Nightmare. If you can beat this mode you have balls of steel.
											// Or you cheated.

///////////////////////////////////////////////////////////////////////////////
// Public Vars
///////////////////////////////////////////////////////////////////////////////
var() string WeekendStartURL;
var() class<AWCatPawn> ApocalypseCatClass;
var() class<AWGaryHead> GaryHeadClass;
var() class<ZombieHead> ZombieHeadClass;
var string AW7MutatorClassName;

///////////////////////////////////////////////////////////////////////////////
// Internal Vars
///////////////////////////////////////////////////////////////////////////////
var Material FireCorona;
var float NewCatTime;	// When we'll make a new cat
var float CatRainTime;	// When we'll start raining again
var bool bRainingCats;
var bool bNightmareSave;	// Saved already on this level in nightmare

///////////////////////////////////////////////////////////////////////////////
// More Consts
///////////////////////////////////////////////////////////////////////////////
const NEW_CAT_BASE_TIME	= 5;
const NEW_CAT_RAND_TIME	= 5;
const RAIN_BASE_TIME	= 60;
const RAIN_RAND_TIME	= 120;
const CAT_MAKE_RANGE_DIST=4000;
const CAT_MAKE_RANGE_XY = 1500;
const CAT_MAKE_BASE_DIST= 200;
const CAT_MAKE_Z		= 3000;
const CAT_RAIN_SPEED	= 100;
const CAT_RAIN_ACC		= -1200;

const DAY_FRIDAY = 4;
const DAY_SATURDAY = 5;

///////////////////////////////////////////////////////////////////////////////
// In super-hard Heston mode
///////////////////////////////////////////////////////////////////////////////
function bool InHestonmode()
{
	return (GetGameDifficulty() == HESTON_DIFFICULTY
			|| GetGameDifficulty() == NIGHTMARE_DIFFICULTY);
}

///////////////////////////////////////////////////////////////////////////////
// In They Hate Me mode. Cops don't arrest you and everyone hates you that has
// a weapon. very Hard
///////////////////////////////////////////////////////////////////////////////
function bool TheyHateMeMode()
{
	return (GetGameDifficulty() == THEYHATEME_DIFFICULTY
			|| GetGameDifficulty() == NIGHTMARE_DIFFICULTY
			|| GetGameDifficulty() == FUCKING_HARD_DIFFICULTY);
}

///////////////////////////////////////////////////////////////////////////////
// In super-duper-hard Insane-o mode
///////////////////////////////////////////////////////////////////////////////
function bool InInsanemode()
{
	return (GetGameDifficulty() == INSANE_O_DIFFICULTY
			|| GetGameDifficulty() == FUCKING_HARD_DIFFICULTY);
}

///////////////////////////////////////////////////////////////////////////////
// In extremely hard Nightmare mode
///////////////////////////////////////////////////////////////////////////////
function bool InNightmareMode()
{
	return (GetGameDifficulty() == NIGHTMARE_DIFFICULTY
			|| GetGameDifficulty() == FUCKING_HARD_DIFFICULTY);
}

///////////////////////////////////////////////////////////////////////////////
// In next-to-impossible Fucking Hard mode
///////////////////////////////////////////////////////////////////////////////
function bool FuckingHardMode()
{
	return (GetGameDifficulty() == FUCKING_HARD_DIFFICULTY);
}

///////////////////////////////////////////////////////////////////////////////
// Returns true if we're on Saturday or Sunday
///////////////////////////////////////////////////////////////////////////////
function bool IsWeekend()
{
	return (TheGameState.CurrentDay >= DAY_SATURDAY);
}

///////////////////////////////////////////////////////////////////////////////
// Returns true if this game is only Saturday and Sunday
///////////////////////////////////////////////////////////////////////////////
function bool WeekendOnlyGame()
{
	return false;
}

///////////////////////////////////////////////////////////////////////////////
// Returns true if this game includes Saturday and Sunday
///////////////////////////////////////////////////////////////////////////////
function bool WeekendGame()
{
	return true;
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function KillTravelInv()
{
	local Pawn P;
	local P2Player P2P;
	local TravelInv T;

	P = GetPlayer().Pawn;

	foreach AllActors(class'TravelInv',T)
	{
		P.DeleteInventory(T);
		T.Destroy();
	}
}

/*
///////////////////////////////////////////////////////////////////////////////
// Hack
///////////////////////////////////////////////////////////////////////////////
function SearchForOldControllers()
{
	foreach DynamicActors(class'AWPerson', P)
		if (P.Controller.class == class'BystanderController')
			ConvertController(P);
}

function ConvertController(AWPerson P)
{
	P.Controller.Destroy();
	P.Controller = None;
	P.Controller = spawn(class'AW7CivilianController');
	if(P.Controller != None )
	{
		P.Controller.Possess(P);
		AIController(P.Controller).Skill += P.SkillModifier;
		P.CheckForAIScript();
	}
}
*/

function int ReduceDamage( int Damage, pawn injured, pawn instigatedBy, vector HitLocation, out vector Momentum, class<DamageType> DamageType )
{
	if (IsCinematic() && AW7PostalDude(Injured) != None)
		return 0;
	else
		return Super.ReduceDamage(Damage, Injured, InstigatedBy, HitLocation, Momentum, DamageType);
}

///////////////////////////////////////////////////////////////////////////////
// HACK -- switch weapons to shiny or non-shiny textures
///////////////////////////////////////////////////////////////////////////////
function HackMakeShiny()
{
	local MaDBloodWeapon W;
//	local P2WeaponPickup P;

	foreach DynamicActors(class'MaDBloodWeapon', W)
		W.MakeShiny();
}

///////////////////////////////////////////////////////////////////////////////
// HACK -- switch weapons to shiny or non-shiny textures
///////////////////////////////////////////////////////////////////////////////
function HackMakeUnShiny()
{
	local MaDBloodWeapon W;
//	local P2WeaponPickup P;

	foreach DynamicActors(class'MaDBloodWeapon', W)
		W.MakeUnShiny();
}

///////////////////////////////////////////////////////////////////////////////
// REALLY BAD HACK.
// The "proper" way is to subclass all these pawns. But I don't have the time...
///////////////////////////////////////////////////////////////////////////////
function HackChanger(class<AWPerson> PawnClass, bool bIsZombie, bool bIsGary)
{
	if (bIsZombie)
		PawnClass.Default.HeadClass = ZombieHeadClass;
	else if (bIsGary)
		PawnClass.Default.HeadClass = GaryHeadClass;
	else
		PawnClass.Default.HeadClass = class'AW7Person'.Default.HeadClass;

	if (!bIsGary)
	{
		PawnClass.Default.LimbClass = class'AW7Person'.Default.LimbClass;
		PawnClass.Default.StumpClass = class'AW7Person'.Default.StumpClass;
	}

	PawnClass.Default.GutsEmitterClass1 = class'AW7Person'.Default.GutsEmitterClass1;
	PawnClass.Default.GutsEmitterClass2 = class'AW7Person'.Default.GutsEmitterClass2;
}

///////////////////////////////////////////////////////////////////////////////
// REALLY BAD HACK.
// The "proper" way is to subclass all these pawns. But I don't have the time...
///////////////////////////////////////////////////////////////////////////////
function HackChangeHeadLimbAndGutsClass()
{
	HackChanger(class'AWMilitary',false,false);
	HackChanger(class'AWGary',false,true);
	HackChanger(class'AWSuperGary',false,true);
	HackChanger(class'BattleDamageGary',false,true);
	HackChanger(class'AWZombie',true,false);
	HackChanger(class'AWZombieCharger',true,false);
	HackChanger(class'AWZombieNoCharge',true,false);
	HackChanger(class'AWZombieNoSpit',true,false);
	HackChanger(class'AWZombieSpitter',true,false);
	HackChanger(class'AWZombieSuperCharger',true,false);
	HackChanger(class'AWZombieSuperSpitter',true,false);
	HackChanger(class'AWZombieTom',true,false);
	HackChanger(class'AnimalProtestors',false,false);
	HackChanger(class'AWBystanders',false,false);
	HackChanger(class'AWFanatics',false,false);
	HackChanger(class'AWSuperFanatics',false,false);
	HackChanger(class'AWRednecks',false,false);
	HackChanger(class'AWScaredGary',false,false);
	HackChanger(class'InvisiGuard',false,false);
	HackChanger(class'PhraudHogslop',false,false);
	HackChanger(class'PublisherGuard',false,false);

	if (TheyHateMeMode())
	{
		HackChangePawnSpawners();
		class'AWMilitary'.default.ControllerClass = class'AW7CivilianController';
		class'PublisherGuard'.default.ControllerClass = class'AW7CivilianController';
	}
}

function HackChangePawnSpawners()
{
	local PawnSpawner P;
	
	foreach DynamicActors(class'PawnSpawner', P)
		if (P.InitControllerClass == class'AWMilitaryController')
			P.InitControllerClass = class'AW7CivilianController';
}

///////////////////////////////////////////////////////////////////////////////
// Hacky, but could be worse...
///////////////////////////////////////////////////////////////////////////////
function SetWeaponOrder()
{
	const MachetePath = "AWInventory.MacheteWeapon";
	const ScythePath = "AWInventory.ScytheWeapon";
	const MeatcleaverPath = "AW7Inventory.MeatcleaverWeapon";
	const PitchforkPath = "AW7Inventory.PitchforkWeapon";
	const KatanaPath = "AW7Inventory.KatanaWeapon";
	const MaDBAxePath = "AW7MaDInventory.MaDBAxeWeapon";
	const MaDLAxePath = "AW7MaDInventory.MaDLAxeWeapon";
	const PistolPath = "Inventory.PistolWeapon";
	const MaDSPistolPath = "AW7MadInventory.MaDSPistolWeapon";
	const MaDColtPath = "AW7MaDInventory.MaDColtWeapon";
	const ShotgunPath = "Inventory.ShotgunWeapon";
	const SMEGPath = "AW7Inventory.SMGEWeapon";

	// Reorder various melee weapons. Also a hack, but unavoidable.
	class'MacheteWeapon'.Default.GroupOffset = 50;
	class'ScytheWeapon'.Default.GroupOffset = 51;

	if (bNewWeaponOrder)
	{
		Level.ConsoleCommand("set"@MachetePath@"InventoryGroup 2");
		Level.ConsoleCommand("set"@ScythePath@"InventoryGroup 2");
		Level.ConsoleCommand("set"@MeatcleaverPath@"InventoryGroup 2");
		Level.ConsoleCommand("set"@PitchforkPath@"InventoryGroup 2");
		Level.ConsoleCommand("set"@KatanaPath@"InventoryGroup 2");
		Level.ConsoleCommand("set"@MaDBAxePath@"InventoryGroup 2");
		Level.ConsoleCommand("set"@MaDLAxePath@"InventoryGroup 2");

		Level.ConsoleCommand("set"@PistolPath@"InventoryGroup 3");
		Level.ConsoleCommand("set"@MaDSPistolPath@"InventoryGroup 3");
		Level.ConsoleCommand("set"@MaDColtPath@"InventoryGroup 3");

		Level.ConsoleCommand("set"@ShotgunPath@"GroupOffset 4");
		Level.ConsoleCommand("set"@SMEGPath@"GroupOffset 5");
	}
	else
	{
		Level.ConsoleCommand("set"@MachetePath@"InventoryGroup 1");
		Level.ConsoleCommand("set"@ScythePath@"InventoryGroup 1");
		Level.ConsoleCommand("set"@MeatcleaverPath@"InventoryGroup 1");
		Level.ConsoleCommand("set"@PitchforkPath@"InventoryGroup 1");
		Level.ConsoleCommand("set"@KatanaPath@"InventoryGroup 1");
		Level.ConsoleCommand("set"@MaDBAxePath@"InventoryGroup 1");
		Level.ConsoleCommand("set"@MaDLAxePath@"InventoryGroup 1");

		Level.ConsoleCommand("set"@PistolPath@"InventoryGroup 2");
		Level.ConsoleCommand("set"@MaDSPistolPath@"InventoryGroup 2");
		Level.ConsoleCommand("set"@MaDColtPath@"InventoryGroup 2");

		Level.ConsoleCommand("set"@ShotgunPath@"GroupOffset 1");
		Level.ConsoleCommand("set"@SMEGPath@"GroupOffset 2");
	}

	if (bShinyWeapons)
		HackMakeShiny();
	else
		HackMakeUnShiny();
}

///////////////////////////////////////////////////////////////////////////////
// Destroy weapons we don't use anymore (Basey, Pitchfork, etc)
///////////////////////////////////////////////////////////////////////////////
function DestroyUnusedWeapons()
{
	local P2WeaponPickup Pick;

	foreach DynamicActors(class'P2WeaponPickup', Pick)
	{
		if (Pick.Class == class'MaDBaseyPickup'			// Spiked bat
			|| Pick.Class == class'PitchforkPickup'		// Pitchfork
			|| Pick.Class == class'MaDHammerPickup'		// Warhammer
			|| Pick.Class == class'MadMacePickup'		// Chaos Mace
			|| Pick.Class == class'DustersPickup')		// Dusters
			if (!Pick.bForTransferOnly) // only if it's not for transfer
				Pick.Destroy();
	}
}

///////////////////////////////////////////////////////////////////////////////
// This function is called before any other scripts (including PreBeginPlay().
///////////////////////////////////////////////////////////////////////////////
event InitGame(out string Options, out string Error)
{
	local AnimalPawn Animal;

	Super.InitGame(Options, Error);
	MySlotInfoMgr = spawn(class'AW7SlotInfoMgr');

	HackChangeHeadLimbAndGutsClass();
	SetWeaponOrder();
	DestroyUnusedWeapons();

	// Raise lifespan of gas trail. Also a hack.
	class'GasTrail'.Default.LifeSpan = 160;
	class'ScissorsWeapon'.Default.WeaponSpeedShoot1 = class'ScissorsWeapon'.Default.WeaponSpeedShoot1MP;
	class'ScissorsWeapon'.Default.WeaponSpeedShoot2 = class'ScissorsWeapon'.Default.WeaponSpeedShoot2MP;

	if (AW7GameState(TheGameState).RedTurtleDay <= 0)
	{
		AW7GameState(TheGameState).RedTurtleDay=Rand(5);
		//log(self@"set red turtle day to"@AW7GameState(TheGameState).RedTurtleDay$". Don't forget to remove this log message!");
	}
//	else
//		log(self@"red turtle day is"@AW7GameState(TheGameState).RedTurtleDay$". Don't forget to remove this log message!");

	// Let telepads travel more pawns
//	class'Telepad'.Default.TravelRadius = 4800;

	AddMutator(AW7MutatorClassName);

	// Attempted crash fix DeadBodyMarker. Doesn't seem to work well.
//	class'DeadBodyMarker'.Default.NotifyTime = 2.5;

	// This didn't work the way I wanted, so stubbed
//	class'FirePuddle'.Default.LightBrightness = 128;
//	class'FirePuddle'.Default.LightHue = 255;
//	class'FirePuddle'.Default.LightSaturation = 127;
//	class'FirePuddle'.Default.LightType = LT_Flicker;
//	class'FirePuddle'.Default.bDynamicLight = True;
//	class'FirePuddle'.Default.DrawScale = 0.5;
//	class'FirePuddle'.Default.bCorona = True;
//	class'FirePuddle'.Default.Skins[0] = FireCorona;

	// Nightmare mode stuff
	if (InNightmareMode())
	{
		// In nightmare mode, prevent stored health pickups other than crack.
		class'FastFoodPickup'.Default.InventoryType = class'FastFoodInvAuto';
		class'PizzaPickup'.Default.InventoryType = class'PizzaInvAuto';
		class'DonutPickup'.Default.InventoryType = class'DonutInvAuto';
		class'MaDBeerPickup'.Default.InventoryType = class'AW7Inventory.MadBeerInvAuto';

		// Animals go crazy
		//foreach DynamicActors(class'AnimalPawn', Animal)
		//	Animal.bGunCrazy = True;
	}
	else
	{
		class'FastFoodPickup'.Default.InventoryType = class'FastFoodInv';
		class'PizzaPickup'.Default.InventoryType = class'PizzaInv';
		class'DonutPickup'.Default.InventoryType = class'DonutInv';
		class'MaDBeerPickup'.Default.InventoryType = class'MadBeerInv';
	}
}

///////////////////////////////////////////////////////////////////////////////
// Check to swap out the postal dude's bandaged head skin.
///////////////////////////////////////////////////////////////////////////////
function CheckDudeHeadskin()
{
	local AW7PostalDude TheDude;

	foreach DynamicActors(class'AW7PostalDude', TheDude)
		TheDude.DudeCheckHeadSkin();
}

///////////////////////////////////////////////////////////////////////////////
// As soon as we have a valid game state, check for the dude's bandaged head
///////////////////////////////////////////////////////////////////////////////
event PostTravel(P2Pawn PlayerPawn)
{
	local Inventory invadd;
	local P2PowerupInv ppinv;

	const NIGHTMARE_RADAR_MIN = 2000;

	Super.PostTravel(PlayerPawn);
	CheckDudeHeadSkin();

	AW7DudePlayer(GetPlayer()).CheckGoodies();

	// In nightmare mode, give him a radar with a long battery life
	if (TheGameState.bFirstLevelOfDay && InNightmareMode())
	{
		invadd = PlayerPawn.CreateInventoryByClass(class'RadarInv');
		//log(Self$" invadd "$invadd);
		// Make sure they have enough--if you have more than this, that's fine.
		ppinv = P2PowerupInv(invadd);
		if(ppinv != None
			&& ppinv.Amount < NIGHTMARE_RADAR_MIN)
			ppinv.SetAmount(NIGHTMARE_RADAR_MIN);
	}
}

///////////////////////////////////////////////////////////////////////////////
// As soon as we have a valid game state, check for the dude's bandaged head
///////////////////////////////////////////////////////////////////////////////
event PostLoadGame()
{
	Super.PostLoadGame();
	CheckDudeHeadSkin();

	AW7DudePlayer(GetPlayer()).CheckGoodies();
}

///////////////////////////////////////////////////////////////////////////////
// Add a controller to our newly spawned cat
///////////////////////////////////////////////////////////////////////////////
function AddController(FPSPawn newcat)
{
	if ( newcat.Controller == None
		&& newcat.Health > 0 )
	{
		if ( (newcat.ControllerClass != None))
			newcat.Controller = spawn(newcat.ControllerClass);
		if ( newcat.Controller != None )
			newcat.Controller.Possess(newcat);
		// Check for AI Script
		newcat.CheckForAIScript();
	}
}

///////////////////////////////////////////////////////////////////////////////
// Make sure it's the final day and all of our errands are done.
// *Doesn't* check to make sure it's not the demo.
///////////////////////////////////////////////////////////////////////////////
function bool AfterFinalErrand()
{
	// Last day of the real game and you're done with your errands
	return ((TheGameState.CurrentDay == DAY_FRIDAY)
			&& TheGameState.ErrandsCompletedToday >= Days[TheGameState.CurrentDay].NumActiveErrands());
}

///////////////////////////////////////////////////////////////////////////////
// Send player to the AW intro movie
///////////////////////////////////////////////////////////////////////////////
function StartWeekend(PlayerController Player)
{
	bShowDayDuringLoad = True;
	SendPlayerTo(Player, WeekendStartURL);
}

///////////////////////////////////////////////////////////////////////////////
// Send player to the next day
///////////////////////////////////////////////////////////////////////////////
function SendPlayerToNextDay(PlayerController player)
{
	// See if there's any more days
	if (TheGameState.CurrentDay + 1 < Days.length)
	{
		TheGameState.bChangeDayPostTravel = true;
		TheGameState.NextDay = TheGameState.CurrentDay + 1;
//		log(self@"SendPlayerToNextDay: Next day is"@TheGameState.NextDay);
		if (TheGameState.NextDay == DAY_SATURDAY)
			SendPlayerTo(Player, WeekendStartURL);
		else
			SendPlayerTo(player, StartNextDayURL);
	}
	else
	{
		// This shouldn't happen because the end-of-game movie
		// should end up calling EndOfGame() instead.  If it does
		// happen we'll treat it like a quit.
		QuitGame();
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
static final function string Lower(coerce string Text) {

  local int IndexChar;

  for (IndexChar = 0; IndexChar < Len(Text); IndexChar++)
    if (Mid(Text, IndexChar, 1) >= "A" &&
        Mid(Text, IndexChar, 1) <= "Z")
      Text = Left(Text, IndexChar) $ Chr(Asc(Mid(Text, IndexChar, 1)) + 32) $ Mid(Text, IndexChar + 1);

  return Text;
  }

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function string ParseLevelName(string In)
{
	local string S;

	S = Super.ParseLevelName(In);

	if (Right(S,4) ~= ".FUK")
		S = Left(S, Len(S)-4);

	return Lower(S);
}
/*
///////////////////////////////////////////////////////////////////////////////
// Check to remove this pickup from the GottenPickups list.
///////////////////////////////////////////////////////////////////////////////
function FindInPickupList(Pickup DelMe, String Lname)
{
	local int i;

	log(self@"searching for gotten pickup"@DelMe.Name@"from level"@LName);
	for(i=0; i<TheGameState.GottenPickups.Length; i++)
	{
		log(self$" checking"@TheGameState.GottenPickups[i].PickupName@"from level"@TheGameState.GottenPickups[i].LevelName);
		log(self@TheGameState.GottenPickups[i].PickupName@"=="@DelMe.Name$":"@string(TheGameState.GottenPickups[i].PickupName == DelMe.name));
		log(self@TheGameState.GottenPickups[i].LevelName@"~="@LName$":"@string(TheGameState.GottenPickups[i].LevelName ~= LName));
		if(TheGameState.GottenPickups[i].PickupName == DelMe.name
			&& TheGameState.GottenPickups[i].LevelName ~= Lname)
		{
			log(self$"												Removing "$DelMe);
			DelMe.Destroy();
			DelMe = None;
			break;
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
//
// Go through all the pickups in the level, and remove any that have been
// previously taken by the dude.
//
///////////////////////////////////////////////////////////////////////////////
function RemoveGottenPickups()
{
	local Pickup CheckP, DelMe;
	local String Lname;

	Lname = ParseLevelName(Level.GetLocalURL());

	log(self$" RemoveGottenPickups for level"@Lname$", gottenpickups length "$TheGameState.GottenPickups.Length);

	foreach AllActors(class'Pickup', CheckP)
	{
		DelMe = CheckP;
//		log(self$" RemoveGottenPickups "$DelMe);
		// If you're not allowed to be recorded, you're not allowed to be restored
		if((P2WeaponPickup(DelMe) != None
				&& P2WeaponPickup(DelMe).bRecordAfterPickup)
			|| (P2PowerupPickup(DelMe) != None
					&& P2PowerupPickup(DelMe).bRecordAfterPickup)
			|| (P2AmmoPickup(DelMe) != None
					&& P2AmmoPickup(DelMe).bRecordAfterPickup))
		{
			FindInPickupList(DelMe, Lname);
		}
	}
}
*/
///////////////////////////////////////////////////////////////////////////////
// Rounds float X to DecimalPlaces places.
///////////////////////////////////////////////////////////////////////////////
static final function float Round(float X, int DecimalPlaces)
{
	local float Y;
	local int Z;

//	log("Round" @ X @ "to" @ DecimalPlaces @ "decimal places");
	Y = X * (10^DecimalPlaces);
	Z = Int(Y);
	Y = float(Z) / (10^DecimalPlaces);
//	log("Result is" @ Y);

	return Y;
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function int GetRefVal(float Ref, float Parm1, float Parm2, float Parm3)
{
	local int Y;

	Y = Int((Ref + Parm1) * Parm2 / (Ref ^ Parm3));
	return Y;
}

///////////////////////////////////////////////////////////////////////////////
// Make sure these are done at StartGame and every time you load, in case,
// in between, someone deletes their ini, but uses an old load
///////////////////////////////////////////////////////////////////////////////
function PrepIniStartVals()
{
	GameRefVal = int(ConsoleCommand("get "@RefPath));

	if(GameRefVal == START_GAME_REF)
	{
		// Setup the reference value
		GameRefVal=(Rand(REF_STARTUP)/2);
		GameRefVal=2*GameRefVal;
		ConsoleCommand("set "@RefPath@GameRefVal);
//		log(self$" NEW made up gameref "$GameRefVal);

		InitVal = GetRefVal(GameRefVal, INIT_1, INIT_2, INIT_3);
		SaveVals(InitVal);
	}
	else
//		log(self$" CURRENT gameref "$GameRefVal);

	if(CoolStart == 0)
	{
		CoolStart = Rand(COOL_FACTOR);
		ConsoleCommand("set "@CoolStartPath@CoolStart);
	}

	if (InitVal != GetRefVal(GameRefVal, INIT_1, INIT_2, INIT_3))
	{
//		log(self@"Invalid InitVal ("$InitVal$") -- resetting");
		ZeroAllCheats();
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function SaveVals(
	optional int NewInit,
	optional int NewCorn,
	optional int NewUber,
	optional int NewMetool,
	optional int NewBusta,
	optional int NewFathom,
	optional int NewMatrix,
	optional int NewFook)
{

	if (NewInit != 0)
	{
		InitVal = NewInit;
//		log (self@"NEW InitVal --"@InitVal);
	    ConsoleCommand("set "@INIT_PATH@InitVal);
    }

	if (NewCorn != 0)
	{
		CornHole = NewCorn;
//		log (self@"NEW CornHole -- "@CornHole);
	    ConsoleCommand("set "@CORN_PATH@CornHole);
	}

	if (NewUber != 0)
	{
		UberSquire = NewUber;
//		log (self@"NEW UberSquire --"@UberSquire);
	    ConsoleCommand("set "@UBER_PATH@UberSquire);
	}

	if (NewMetool != 0)
	{
		MetoolAlloy = NewMetool;
//		log (self@"NEW Metool --"@MetoolAlloy);
	    ConsoleCommand("set "@METOOL_PATH@MetoolAlloy);
	}

	if (NewBusta != 0)
	{
		BustaRhymes = NewBusta;
//		log (self@"NEW Busta --"@BustaRhymes);
	    ConsoleCommand("set "@BUSTA_PATH@BustaRhymes);
	}

	if (NewFathom != 0)
	{
		UnFathomable = NewFathom;
//		log (self@"NEW UnFathomable --"@UnFathomable);
	    ConsoleCommand("set "@FATHOM_PATH@UnFathomable);
	}

	if (NewMatrix != 0)
	{
		MatrixMan = NewMatrix;
//		log (self@"NEW Matrix --"@MatrixMan);
	    ConsoleCommand("set "@MATRIX_PATH@MatrixMan);
	}

	if (NewFook != 0)
	{
		FookedUp = NewFook;
//		log (self@"NEW Matrix --"@MatrixMan);
	    ConsoleCommand("set "@FOOK_PATH@MatrixMan);
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function ZeroAllCheats()
{
	InitVal = GetRefVal(GameRefVal, INIT_1, INIT_2, INIT_3);
	SaveVals(InitVal, -1, -1, -1, -1, -1, -1, -1);
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function EnableAllCheats()
{
	InitVal = GetRefVal(GameRefVal, INIT_1, INIT_2, INIT_3);
	SaveVals(
		InitVal,
		GetRefVal(InitVal, CORN_1, CORN_2, CORN_3),
		GetRefVal(InitVal, UBER_1, UBER_2, UBER_3),
		GetRefVal(InitVal, METOOL_1, METOOL_2, METOOL_3),
		GetRefVal(InitVal, BUSTA_1, BUSTA_2, BUSTA_3),
		GetRefVal(InitVal, FATHOM_1, FATHOM_2, FATHOM_3),
		GetRefVal(InitVal, MATRIX_1, MATRIX_2, MATRIX_3),
		GetRefVal(InitVal, FOOK_1, FOOK_2, FOOK_3)
	);
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function EnableMetool()
{
	SaveVals(,,, GetRefVal(InitVal, METOOL_1, METOOL_2, METOOL_3));
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function EnableBusta()
{
	SaveVals(,,,, GetRefVal(InitVal, BUSTA_1, BUSTA_2, BUSTA_3));
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function EnableFathom()
{
	SaveVals(,,,,, GetRefVal(InitVal, FATHOM_1, FATHOM_2, FATHOM_3));
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function EnableMatrix()
{
	SaveVals(,,,,,, GetRefVal(InitVal, MATRIX_1, MATRIX_2, MATRIX_3));
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function EnableFook()
{
	SaveVals(,,,,,,, GetRefVal(InitVal, FOOK_1, FOOK_2, FOOK_3));
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function bool SissyEnabled()
{
	local int Ref;
	local int OldVal;

    ref = GetRefVal(InitVal, UBER_1, UBER_2, UBER_3);
//	log(self@"CheckSissy: UberSquire ="@UberSquire@"Must match"@ref);
	if (UberSquire == Ref)
		return true;
	else
	{
		OldVal = Int(ConsoleCommand("get"@UBER_PATH));
//		log(self@"CheckSissy Take 2: OldVal ="@OldVal@"Must match"@ref);
		return (OldVal == Ref);
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function bool FookEnabled()
{
	local int Ref;
	local int OldVal;

    ref = GetRefVal(InitVal, FOOK_1, FOOK_2, FOOK_3);
//	log(self@"CheckMatrix: MatrixMan ="@MatrixMan@"Must match"@ref);
	if (MatrixMan == Ref)
		return true;
	else
	{
		OldVal = Int(ConsoleCommand("get"@FOOK_PATH));
//		log(self@"CheckMatrix Take 2: OldVal ="@OldVal@"Must match"@ref);
		return (OldVal == Ref);
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function bool MatrixEnabled()
{
	local int Ref;
	local int OldVal;

    ref = GetRefVal(InitVal, MATRIX_1, MATRIX_2, MATRIX_3);
//	log(self@"CheckMatrix: MatrixMan ="@MatrixMan@"Must match"@ref);
	if (MatrixMan == Ref)
		return true;
	else
	{
		OldVal = Int(ConsoleCommand("get"@MATRIX_PATH));
//		log(self@"CheckMatrix Take 2: OldVal ="@OldVal@"Must match"@ref);
		return (OldVal == Ref);
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function bool MetoolEnabled()
{
	local int Ref;
	local int OldVal;

    ref = GetRefVal(InitVal, Metool_1, Metool_2, Metool_3);
//	log(self@"CheckMetool: MetoolAlloy ="@MetoolAlloy@"Must match"@ref);
	if (MetoolAlloy == Ref)
		return true;
	else
	{
		OldVal = Int(ConsoleCommand("get"@Metool_PATH));
//		log(self@"CheckMetool Take 2: OldVal ="@OldVal@"Must match"@ref);
		return (OldVal == Ref);
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function bool BustaEnabled()
{
	local int Ref;
	local int OldVal;

    ref = GetRefVal(InitVal, Busta_1, Busta_2, Busta_3);
//	log(self@"CheckBusta: BustaRhymes ="@BustaRhymes@"Must match"@ref);
	if (BustaRhymes == Ref)
		return true;
	else
	{
		OldVal = Int(ConsoleCommand("get"@Busta_PATH));
//		log(self@"CheckBusta Take 2: OldVal ="@OldVal@"Must match"@ref);
		return (OldVal == Ref);
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function bool FathomEnabled()
{
	local int Ref;
	local int OldVal;

    ref = GetRefVal(InitVal, Fathom_1, Fathom_2, Fathom_3);
//	log(self@"CheckFathom: UnFathomable ="@UnFathomable@"Must match"@ref);
	if (UnFathomable == Ref)
		return true;
	else
	{
		OldVal = Int(ConsoleCommand("get"@Fathom_PATH));
//		log(self@"CheckFathom Take 2: OldVal ="@OldVal@"Must match"@ref);
		return (OldVal == Ref);
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function bool AllEnabled()
{
	return (
		FinallyOver() &&
		MatrixEnabled() &&
		MetoolEnabled() &&
		BustaEnabled() &&
		FathomEnabled()
		);
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function EnableSissy()
{
	UberSquire = GetRefVal(InitVal, UBER_1, UBER_2, UBER_3);
	SaveVals(,,UberSquire);
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function DisableSissy()
{
	SaveVals(,,-1);
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function RecordEnding()
{
//	FOver = FOVER_SUM - GameRefVal;
//	TimesBeatenGame++;
//	ConsoleCommand("set "@FOverPath@FOver);
//	ConsoleCommand("set "@TimesBeatenGamePath@TimesBeatenGame);
	Super.RecordEnding();

	CornHole = GetRefVal(InitVal, CORN_1, CORN_2, CORN_3);
	SaveVals(,CornHole);
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function bool FinallyOver()
{
	local int Ref;
	local int OldVal;

    ref = GetRefVal(InitVal, Corn_1, Corn_2, Corn_3);
//	log(self@"CheckCorn: CornHole ="@CornHole@"Must match"@ref);
	if (CornHole == Ref)
		return true;
	else
	{
		OldVal = Int(ConsoleCommand("get"@Corn_PATH));
//		log(self@"CheckFOver Take 2: OldVal ="@OldVal@"Must match"@ref);
		return (OldVal == Ref);
	}
}

///////////////////////////////////////////////////////////////////////////////
// Check last code
///////////////////////////////////////////////////////////////////////////////
function bool VerifySeqTime(optional bool bUpdate)
{
	local bool bEStartCheck;
	local bool bverified;

	if(bUpdate)
		InfoSeqTime = int(ConsoleCommand("get "@InfoSeqPath));

	if (TheGameState.bEGameStart && FinallyOver())
		return true;
	else
		return false;
}

///////////////////////////////////////////////////////////////////////////////
// Reach into entry and put a new reference to every chameleon texture/meshes in this
// level.
///////////////////////////////////////////////////////////////////////////////
function StoreChams()
{
	local LevelInfo lev;
	local TextureLoader texl;
	local MeshLoader mesher;
	local Actor checkme;
	local PersonPawn checkpawn;

	lev = GetPlayer().GetEntryLevel();

//	log(self$" StoreChams "$lev);

	foreach lev.AllActors(class'Actor', checkme)
	{
		if(TextureLoader(checkme) != None)
			texl = TextureLoader(checkme);
		else if(MeshLoader(checkme) != None)
			mesher = MeshLoader(checkme);
	}

//	log(self$" checking texture loader "$mesher$" mesh loader "$mesher);
	if(texl != None
		&& mesher != None)
	{
		// Clear the lists
		texl.ClearArray();
		mesher.ClearArray();
		// Now go through each pawn and put their textures/meshes into the list
		foreach DynamicActors(class'PersonPawn', checkpawn)
		{
			texl.AddTexture(checkpawn.Skins[0]);
			mesher.AddMesh(checkpawn.Mesh);
			if(checkpawn.MyHead != None)
			{
				texl.AddTexture(checkpawn.MyHead.Skins[0]);
				mesher.AddMesh(checkpawn.MyHead.Mesh);
			}
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
// Check to rain cats during the apocalypse
///////////////////////////////////////////////////////////////////////////////
function CheckCatRain(float DeltaTime)
{
	local P2Player p2p;
//	local CatRocket catr;
	local AWCatPawn catr;
	local vector dir, StartLoc;
	local float tempf;

	CatRainTime -= DeltaTime;

	// Check to toggle rain
	if(CatRainTime <= 0)
	{
		bRainingCats = !bRainingCats;
		if(bRainingCats)
			CatRainTime = RAIN_BASE_TIME + Rand(RAIN_RAND_TIME);
		else
			CatRainTime = Rand(RAIN_BASE_TIME);
	}

	if(bRainingCats)
	{
		NewCatTime -= DeltaTime;
		if(NewCatTime <= 0)
		{
			p2p = GetPlayer();
			if(p2p != None
				&& p2p.MyPawn != None)
			{
				NewCatTime = NEW_CAT_BASE_TIME + Rand(NEW_CAT_RAND_TIME);
				// Make it generally in front of the player
				// Move it in front of him
				StartLoc = vector(p2p.MyPawn.Rotation);
				StartLoc.z = 0;
				StartLoc = (FRand()*CAT_MAKE_RANGE_DIST + CAT_MAKE_BASE_DIST) * StartLoc;
				// Vaguely center the rain if he's dead
				if(p2p.MyPawn.Health <= 0)
				{
					tempf = 0.5*(CAT_MAKE_RANGE_DIST + CAT_MAKE_BASE_DIST);
					StartLoc.x += tempf;
					StartLoc.y += tempf;
				}
				// Now create a range around that point
				tempf = (0.5*CAT_MAKE_RANGE_XY);
				StartLoc.x = StartLoc.x + (FRand()*CAT_MAKE_RANGE_XY - tempf);
				StartLoc.y = StartLoc.y + (FRand()*CAT_MAKE_RANGE_XY - tempf);
				// Move it above him
				StartLoc.z += CAT_MAKE_Z;
				StartLoc = StartLoc + p2p.MyPawn.Location;
				dir = VRand();
				dir.z=-1;
//				catr = spawn(class'CatRocket',,,StartLoc,Rotator(dir));
				catr = spawn(ApocalypseCatClass,,, StartLoc, Rotator(Dir));
				if(catr != None)
				{
					AddController(CatR);
					catr.AmbientGlow=255;	// make them pulse so they're easier to see.
					// modify speed for a gentle rain
					Dir = vector(catr.Rotation);
					catr.Velocity = CAT_RAIN_SPEED * Dir;
					catr.Acceleration.z = CAT_RAIN_ACC;
				}
			}
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
// Monitor things in the game, and rain cats
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
state RunningApocalypse
{
	function BeginState()
	{
		Super.BeginState();
		// Init new cat time, the first time the level starts
		NewCatTime = NEW_CAT_BASE_TIME + Rand(NEW_CAT_RAND_TIME);
	}
}

///////////////////////////////////////////////////////////////////////////////
// Copied from AWGameSPFinal, since we extend from AWGameSP and not
// AWGameSPFinal
///////////////////////////////////////////////////////////////////////////////
function bool PickupQuery( Pawn Other, Pickup item )
{
	// In nightmare mode, prevent stored health pickups other than crack.
	if (AW7PostalDude(Other) != None)
		if (Item.Class == class'FastFoodPickup'
			|| Item.Class == class'PizzaPickup'
			|| Item.Class == class'DonutPickup'
			|| Item.Class == class'MaDBeerPickup')
		{
			if (AW7PostalDude(Other).Health > AW7PostalDude(Other).HealthMax)
				return false;
		}

	if(P2WeaponPickup(item) == None
		|| AWDude(Other) == None
		|| AWDude(Other).GaryHeads <= 0
		|| AWDudePlayer(AWDude(Other).Controller).bNeverSwitchOnPickup)	// This variable gets stored and
		// switched to true on creation of a gary head, but if the user goes into the
		// options and switches it manually back and forth, it will come undone. We don't
		// want them doing this, so if they do, don't let them pick up the gun at all.
		// It'll all be back to normal when the heads are gone anyway.
		return Super.PickupQuery(Other, item);
	else
		return false;
}

///////////////////////////////////////////////////////////////////////////////
// Keep track of time elapsed for speed runs and whatnot
///////////////////////////////////////////////////////////////////////////////
event Tick(float Delta)
{
	local P2Player p2p;

	Super.Tick(Delta);

	p2p = GetPlayer();

	if(p2p != None
		&& p2p.Pawn != None
		&& p2p.Pawn.Health > 0
		&& p2p.Level.Pauser == None
		&& TheGameState != None)
		AW7GameState(TheGameState).TimeElapsed += Delta;
}

///////////////////////////////////////////////////////////////////////////////
// Player calls this when it's ready for a save.  It will call this repeatedly
// until it returns true, which means we agree.
///////////////////////////////////////////////////////////////////////////////
function bool ReadyForSave(P2Player player)
	{
	// Set the all-critical flag, then make sure all the other conditions
	// are right.  If it works, then we're good to go.  Otherwise, we clear
	// the flag and wait for the next call.
	bSafeToSave = true;
	if (IsSaveAllowed(player))
		{
		// If an auto save is desired, now is the perfect time to do it
		if (bDoAutoSave)
			SaveGame(AutoSaveSlot, true);

		}
	else
		bSafeToSave = false;

	return bSafeToSave;
	}

///////////////////////////////////////////////////////////////////////////////
// Save game to the specified slot
///////////////////////////////////////////////////////////////////////////////
function SaveGame(int Slot, bool bShowMessage)
	{
	Log(self$" SaveGame(): Slot="$Slot$" bAutoSave="$bDoAutoSave$" bForcedAutoSave="$bForcedAutoSave$" the game state difficulty "$TheGameState.GameDifficulty);

	if (bShowMessage)
		{
		if (Slot == QUICKSAVE_SLOT)
			GetPlayer().ClientMessage(EasySaveMessageString);
		else if (Slot == AUTOSAVE_SLOT && bForcedAutoSave)
			GetPlayer().ClientMessage(ForcedSaveMessageString);
		else if (Slot == AUTOSAVE_SLOT)
			GetPlayer().ClientMessage(AutoSaveMessageString);
		else
			GetPlayer().ClientMessage(NormalSaveMessageString);
		}

	// This slot is now the most recently used slot.  We update this BEFORE the
	// actual save so that if this game is loaded, it will refer to itself as
	// the most recently used.  In other words, whenever a game is loaded, the
	// slot it loaded from becomes the most recently used slot.
	MostRecentGameSlot = Slot;

	// If we're in nightmare mode, record that we've used our one save
	// But not if it's an auto-save (they get a freebie in this case)
	if (InNightmareMode() && !bDoAutoSave)
		bNightmareSave = True;

	// Clear flags before saving so that loaded games don't re-save
	bDoAutoSave = false;
	bForcedAutoSave = false;

	// Do the actual save
	ConsoleCommand("SaveGame "$Slot);

	// Save info about this slot
	MySlotInfoMgr.SetInfo(
		Slot,
		GetCurrentDayBase().Description@"-"@Level.Title@"-"@GetDiffName(TheGameState.GameDifficulty)@"-"@GameNameShort,
		GetCurrentDay(),
		Level.Year$"-"$Val2Str(level.Month, 2)$"-"$Val2Str(Level.Day, 2)@":"@Val2Str(Level.Hour, 2)$":"$Val2Str(Level.Minute, 2),
		int(ConsoleCommand("GETGMTIME")));
	}

///////////////////////////////////////////////////////////////////////////////
// Get the phrase for our difficulty level (override in p2gameinfosingle)
///////////////////////////////////////////////////////////////////////////////
function string GetDiffName(int DiffIndex)
{
	if(DiffIndex < 0)
		DiffIndex = 0;
	else if(DiffIndex > ArrayCount(DifficultyNames))
			DiffIndex = ArrayCount(DifficultyNames);
	return DifficultyNames[DiffIndex];
}

///////////////////////////////////////////////////////////////////////////////
// Can only save once per map in nightmare mode!
///////////////////////////////////////////////////////////////////////////////
function bool IsSaveAllowed(P2Player player)
{
	return (Super.IsSaveAllowed(Player) && (!InNightmareMode() || !bNightmareSave));
}

///////////////////////////////////////////////////////////////////////////////
// Processes "red turtle day" selected at random.
// Actors who have 'RedTurtleDay' in the group will be excluded on all days
// except for the selected "red turtle day".
///////////////////////////////////////////////////////////////////////////////
function NeededForThisDay(Actor CheckA, out byte Needed, out byte SpecifiedDay)
{
	local int RTDay;
	local string GroupString;

	// Call super first. "Red turtle" actors might specify certain days as well,
	// making them even harder to find.
	// Super will return whether we're needed by default (w/o red turtle check)
	Super.NeededForThisDay(CheckA, Needed, SpecifiedDay);

	// Figure out what day the red turtle can be seen.
	RTDay = AW7GameState(TheGameState).RedTurtleDay;
	GroupString = Caps(CheckA.Group);

	// If the actor is a "red turtle" actor then only show it on red turtle days.
	if (InStr(GroupString, REDTURTLE_DAYNAME) >= 0)
	{
		SpecifiedDay = 1;
		if (TheGameState.CurrentDay == RTDay && Needed == 1)
			Needed = 1;
		else
			Needed = 0;
	}
}

// Decided not to do this; people wound up attacking the hordes of zombies and leaving the dude alone.
/*
///////////////////////////////////////////////////////////////////////////////
// In nightmare mode, nobody stays dead for long...
///////////////////////////////////////////////////////////////////////////////
function Killed( Controller Killer, Controller Killed, Pawn KilledPawn, class<DamageType> damageType )
{
	Super.Killed(Killer, Killed, KilledPawn, DamageType);

	if (InNightmareMode() && AWZombie(KilledPawn) == None)
		spawn(class'NightmareSpawner', KilledPawn,, KilledPawn.Location, KilledPawn.Rotation);

}
*/

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////
defaultproperties
{
	//////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////
	// Monday errands
	//////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////

	// Get Paycheck
	Begin Object Class=ErrandGoalGetPickup Name=ErrandGoalGetPaycheck
		PickupTag="PaycheckPickup"
		TriggerOnCompletionTag="PaycheckErrand_ProtestorsAttack"
		HateClass="AW7RWSProtestors"
		HateDesTex="p2misc.map.Hate_Group1Name"
		HatePicTex="p2misc.map.Hate_Group1Pic"
		HateComment="DudeDialog.dude_map_hate1"
	End Object
	Begin Object Class=ErrandBase Name=ErrandBase0
		UniqueName="GetPaycheck"
		NameTex="p2misc.map.PickupCheck_text"
		LocationTex="p2misc.map.PickupCheck_here"
		LocationX=621
		LocationY=246
		LocationCrossTex="p2misc.map.hint_cross_1"
		LocationCrossX=674
		LocationCrossY=252
		DudeStartComment="DudeDialog.dude_map_getcheck"
		DudeWhereComment="DudeDialog.Dude_map_foundrws"	// sounds better before writing location on map
		//DudeFoundComment=
		DudeCompletedComment="DudeDialog.dude_map_anddone"
		Goals(0)=ErrandGoalGetPickup'ErrandGoalGetPaycheck'
	End Object

	// Cash Paycheck
	Begin Object Class=ErrandGoalGiveInventory Name=ErrandGoalGiveInventory1
		InvClassName="PaycheckInv"
		GiveToMeTag="jenny"
		TriggerOnCompletionTag="BankErrand_RobbersShowUp"
	End Object
	Begin Object Class=ErrandGoalGetPickup Name=ErrandGoalGetPickup3
		PickupTag="BankDeposit"
		TriggerOnCompletionTag="BankErrand_CopsShowUp"
	End Object
	Begin Object Class=ErrandBase Name=ErrandBase1
		UniqueName="CashPaycheck"
		NameTex="p2misc.map.CashCheck_text"
		LocationTex="p2misc.map.CashCheck_here"
		LocationX=523
		LocationY=560
		LocationCrossTex="p2misc.map.hint_cross_2"
		LocationCrossX=580
		LocationCrossY=588
		DudeStartComment="DudeDialog.dude_map_cashcheck"
		DudeWhereComment="DudeDialog.Dude_map_loc2"
		DudeFoundComment="DudeDialog.Dude_map_found3"
		DudeCompletedComment="DudeDialog.dude_map_missionaccom"
		Goals(0)=ErrandGoalGiveInventory'ErrandGoalGiveInventory1'
		Goals(1)=ErrandGoalGetPickup'ErrandGoalGetPickup3'
	End Object

	// Get Milk
	Begin Object Class=ErrandGoalGetPickup Name=ErrandGoalGetPickup2
		TriggerOnCompletionTag="MilkErrand_Completed"
		PickupTag="MilkPickup"
	End Object
	Begin Object Class=ErrandBase Name=ErrandBase2
		UniqueName="GetMilk"
		NameTex="p2misc.map.GetMilk_text"
		LocationTex="p2misc.map.GetMilk_here"
		LocationX=660
		LocationY=432
		LocationCrossTex="p2misc.map.hint_cross_3"
		LocationCrossX=664
		LocationCrossY=464
		DudeStartComment="DudeDialog.dude_map_getmilk"
		DudeWhereComment="DudeDialog.Dude_map_loc4"
		DudeFoundComment="DudeDialog.Dude_map_found1"
		DudeCompletedComment="DudeDialog.dude_map_tooeasy"
		Goals(0)=ErrandGoalGetPickup'ErrandGoalGetPickup2'
	End Object

	// Bonus Errand: Deliver Motherboard
	Begin Object Class=ErrandGoalGiveInventory Name=ErrandGoalGiveInventory_ArcadeGuyTakesMotherboard
		InvClassName="MotherboardInv"
		GiveToMeTag="dork"
//		TriggerOnCompletionTag="ArcadeErrand_CopsArrive"
	End Object
	Begin Object Class=ErrandGoalKillMe Name=ErrandGoalKillMe_KillArcadeGuy
		KillMeTag="dork"
//		TriggerOnCompletionTag="ArcadeErrand_CopsArrive"
	End Object
	Begin Object Class=ErrandBase Name=ErrandBase_DeliverMotherboard
		bInitiallyActive=false	// gets activated during gameplay
		UniqueName="DeliverMotherboard"
		NameTex="AW7Tex.Map.Motherboard_text"
		LocationTex="AW7Tex.Map.MoBoMap"
		LocationX=753
		LocationY=406
		LocationCrossTex="p2misc.map.hint_cross_3"
		LocationCrossX=753
		LocationCrossY=416
		DudeStartComment="DudeDialog.dude_map_arcade"
		DudeWhereComment="DudeDialog.Dude_map_loc1"
		DudeFoundComment="DudeDialog.Dude_map_found4"
		DudeCompletedComment="DudeDialog.dude_map_anddone"
		Goals(0)=ErrandGoalGiveInventory'ErrandGoalGiveInventory_ArcadeGuyTakesMotherboard'
		Goals(1)=ErrandGoalKillMe'ErrandGoalKillMe_KillArcadeGuy'
	End Object

	//////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////
	// Tuesday errands
	//////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////

	// Visit Priest
	Begin Object Class=ErrandGoalTalkTo Name=ErrandGoalTalkTo0
		TalkToMeTag="FatherPriest"
		TriggerOnCompletionTag="FanaticSpawner"
	End Object
	Begin Object Class=ErrandGoalKillMe Name=ErrandGoalKillMe1
		KillMeTag="FatherPriest"
		TriggerOnCompletionTag="FanaticSpawner"
	End Object
	Begin Object Class=ErrandBase Name=ErrandBase3
		UniqueName="VisitPriest"
		NameTex="p2misc.map.MakePeaceWithMaker_text"
		LocationTex="p2misc.map.MakePeaceWithMaker_here"
		LocationX=335
		LocationY=282
		LocationCrossTex="p2misc.map.hint_cross_4"
		LocationCrossX=356
		LocationCrossY=319
		DudeStartComment="DudeDialog.dude_map_confess"
		DudeWhereComment="DudeDialog.Dude_map_loc1"
		DudeFoundComment="DudeDialog.Dude_map_found5"
		DudeCompletedComment="DudeDialog.dude_map_closeenough"
		Goals(0)=ErrandGoalTalkTo'ErrandGoalTalkTo0'
		Goals(1)=ErrandGoalKillMe'ErrandGoalKillMe1'
	End Object

	// Get Signatures
	Begin Object Class=ErrandGoalGetAmmoMax Name=ErrandGoalGetAmmoMax0
		TriggerOnCompletionTag="SignaturesErrand_Completed"
		InvClassName="ClipboardWeapon"
	End Object
	Begin Object Class=ErrandBase Name=ErrandBase4
		UniqueName="GetSignatures"
		NameTex="p2misc.map.GetSignatures"
		// takes place everywhere so no location is used
		DudeStartComment="DudeDialog.dude_map_signatures"
		DudeFoundComment="DudeDialog.Dude_map_foundsigs"
		DudeCompletedComment="DudeDialog.dude_map_anddone"
		Goals(0)=ErrandGoalGetAmmoMax'ErrandGoalGetAmmoMax0'
	End Object

	// Return Book
	Begin Object Class=ErrandGoalDropOffPickup Name=ErrandGoalDropOffPickup0
		PickupClassName="LibraryBookPickup"
		DropIntoHereTriggerTag="BookDropOff"
		TriggerOnCompletionTag="BookErrand_ProtestorsAttack"
		HateClass="AW7BookProtestors"
		HateDesTex="p2misc.map.Hate_Group2Name"
		HatePicTex="p2misc.map.Hate_Group2Pic"
		HateComment="DudeDialog.dude_map_hate2"
	End Object
	Begin Object Class=ErrandGoalGiveInventory Name=ErrandGoalGiveInventory2
		InvClassName="LibraryBookInv"
		GiveToMeTag="betty"
		TriggerOnCompletionTag="BookErrand_ProtestorsAttack"
		HateClass="AW7BookProtestors"
		HateDesTex="p2misc.map.Hate_Group2Name"
		HatePicTex="p2misc.map.Hate_Group2Pic"
		HateComment="DudeDialog.dude_map_hate2"
	End Object
	Begin Object Class=ErrandBase Name=ErrandBase5
		UniqueName="ReturnBook"
		NameTex="p2misc.map.ReturnBook_text"
		LocationTex="p2misc.map.ReturnBook_here"
		LocationX=592
		LocationY=494
		LocationCrossTex="p2misc.map.hint_cross_3"
		LocationCrossX=607
		LocationCrossY=521
		DudeStartComment="DudeDialog.dude_map_returnbook"
		DudeWhereComment="DudeDialog.Dude_map_loc4"
		DudeFoundComment="DudeDialog.Dude_map_loc3"
		DudeCompletedComment="DudeDialog.dude_map_donebitch"
		Goals(0)=ErrandGoalDropOffPickup'ErrandGoalDropOffPickup0'
		Goals(1)=ErrandGoalGiveInventory'ErrandGoalGiveInventory2'
	End Object

	// Get Gary's Autograph
	Begin Object Class=ErrandGoalGetInvClassFromPerson Name=ErrandGoalGetInvClassFromPerson2
		TriggerOnCompletionTag="GaryErrand_GotBook"
		InvClassName="GaryBookInv"
		TalkToMeTag="Gary"
	End Object
	Begin Object Class=ErrandGoalGetPickup Name=ErrandGoalGetPickup5
		TriggerOnCompletionTag="GaryErrand_StoleBook"
		PickupTag="GaryBookPickup"
	End Object
	Begin Object Class=ErrandBase Name=ErrandBase6
		UniqueName="GetGary"
		NameTex="p2misc.map.GetGarysAutograph_text"
		LocationTex="p2misc.map.GetGarysAutograph_here"
		LocationX=579
		LocationY=376
		LocationCrossTex="p2misc.map.hint_cross_3"
		LocationCrossX=585
		LocationCrossY=385
		DudeStartComment="DudeDialog.dude_map_getgary"
		DudeWhereComment="DudeDialog.Dude_map_loc1"
		DudeFoundComment="DudeDialog.Dude_map_loc5"
		DudeCompletedComment="DudeDialog.dude_map_closeenough"
		Goals(0)=ErrandGoalGetInvClassFromPerson'ErrandGoalGetInvClassFromPerson2'
		Goals(1)=ErrandGoalGetPickup'ErrandGoalGetPickup5'
	End Object

	//////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////
	// Wednesday errands
	//////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////

	// Visit Dad
	Begin Object Class=ErrandGoalUrineQuotaMet Name=ErrandGoalUrineQuotaMet0
		UrineRecorderTag="DadsGrave"
		HateClass="AW7Rednecks"
		HateDesTex="p2misc.map.Hate_Group3Name"
		HatePicTex="p2misc.map.Hate_Group3Pic"
		HateComment="DudeDialog.dude_map_hate3"
		TriggerOnCompletionTag="AttackAtGrave"
	End Object
	Begin Object Class=ErrandBase Name=ErrandBase7
		UniqueName="VisitDad"
		NameTex="p2misc.map.PissOnDad_text"
		LocationTex="p2misc.map.PissOnDad_here"
		LocationX=371
		LocationY=207
		LocationCrossTex="p2misc.map.hint_cross_3"
		LocationCrossX=387
		LocationCrossY=233
		DudeStartComment="DudeDialog.dude_map_dad"
		DudeWhereComment="DudeDialog.Dude_map_loc1"
		DudeFoundComment="DudeDialog.Dude_map_loc6"
		DudeCompletedComment="DudeDialog.dude_map_next"
		Goals(0)=ErrandGoalUrineQuotaMet'ErrandGoalUrineQuotaMet0'
	End Object

	// Vote
	Begin Object Class=ErrandGoalTag Name=ErrandGoalTag0
		UniqueTag="VoteScreen"
		TriggerOnCompletionTag="VoteErrand_Completed"
	End Object
	Begin Object Class=ErrandBase Name=ErrandBase8
		UniqueName="Vote"
		NameTex="p2misc.map.Vote_text"
		LocationTex="p2misc.map.Vote_here"
		LocationX=659 //758
		LocationY=148 //416
		LocationCrossTex="p2misc.map.hint_cross_3"
		LocationCrossX=688 //787
		LocationCrossY=153 //421
		DudeStartComment="DudeDialog.dude_map_vote"
		DudeWhereComment="DudeDialog.Dude_map_loc2"
		DudeFoundComment="DudeDialog.Dude_map_loc3"
		DudeCompletedComment="DudeDialog.dude_map_tooeasy"
		Goals(0)=ErrandGoalTag'ErrandGoalTag0'
	End Object

	// Get Tree
	Begin Object Class=ErrandGoalGetPickup Name=ErrandGoalGetPickup6
		PickupTag="TreePickup"
		TriggerOnCompletionTag="TreeErrand_Completed"
	End Object
	Begin Object Class=ErrandBase Name=ErrandBase9
		UniqueName="GetTree"
		NameTex="p2misc.map.GetXmasTree_text"
		LocationTex="p2misc.map.GetXmasTree_here"
		LocationX=739
		LocationY=856
		LocationCrossTex="p2misc.map.hint_cross_1"
		LocationCrossX=793
		LocationCrossY=889
		IgnoreTag="BadXmasTree"
		DudeStartComment="DudeDialog.dude_map_gettree"
		DudeWhereComment="DudeDialog.Dude_map_loc4"
		DudeFoundComment="DudeDialog.Dude_map_loc5"
		DudeCompletedComment="DudeDialog.dude_map_donebitch"
		Goals(0)=ErrandGoalGetPickup'ErrandGoalGetPickup6'
	End Object

	// Pickup Laundry
	Begin Object Class=ErrandGoalGetInvClassFromPerson Name=ErrandGoalGetInvClassFromPerson0
		TriggerOnCompletionTag="PickupLaundryErrand_GotClothes"
		InvClassName="DudeClothesInv"
		TalkToMeTag="Qing"
	End Object
	Begin Object Class=ErrandGoalGetPickup Name=ErrandGoalGetPickup1
		TriggerOnCompletionTag="PickupLaundryErrand_StoleClothes"
		PickupTag="DudeClothesPickup"
	End Object
	Begin Object Class=ErrandBase Name=ErrandBase10
		bInitiallyActive=false	// gets activated during gameplay
		UniqueName="PickupLaundry"
		NameTex="p2misc.map.PickupLaundry_text"
		LocationTex="p2misc.map.GetLaundry_here"
		LocationX=739
		LocationY=461
		LocationCrossTex="p2misc.map.hint_cross_2"
		LocationCrossX=794
		LocationCrossY=490
		DudeStartComment="DudeDialog.dude_map_getlaundry"
		DudeWhereComment="DudeDialog.Dude_map_loc1"
		DudeFoundComment="DudeDialog.Dude_map_loc6"
		DudeCompletedComment="DudeDialog.dude_map_next"
		Goals(0)=ErrandGoalGetInvClassFromPerson'ErrandGoalGetInvClassFromPerson0'
		Goals(1)=ErrandGoalGetPickup'ErrandGoalGetPickup1'
	End Object

	//////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////
	// Thursday errands
	//////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////

	// Get Napalm
	Begin Object Class=ErrandGoalGetPickup Name=ErrandGoalGetPickup7
		PickupTag="NapalmPickupErrand"
		TriggerOnCompletionTag="NapalmErrand_Completed"
	End Object
	Begin Object Class=ErrandBase Name=ErrandBase11
		UniqueName="GetNapalm"
		NameTex="p2misc.map.GetNapalm_text"
		LocationTex="p2misc.map.GetNapalm_here"
		LocationX=374
		LocationY=444
		LocationCrossTex="p2misc.map.hint_cross_2"
		LocationCrossX=368
		LocationCrossY=444
		IgnoreTag="NapalmPickupTalk"
		DudeStartComment="DudeDialog.dude_map_getnapalm"
		DudeWhereComment="DudeDialog.Dude_map_loc1"
		DudeFoundComment="DudeDialog.Dude_map_loc3"
		DudeCompletedComment="DudeDialog.dude_partywithnapalm"
		Goals(0)=ErrandGoalGetPickup'ErrandGoalGetPickup7'
	End Object

	// Get Krotchy
	Begin Object Class=ErrandGoalGetPickup Name=ErrandGoalGetPickup8
		PickupTag="KrotchyPickup"
		TriggerOnCompletionTag="KrotchyErrand_Completed"
	End Object
	Begin Object Class=ErrandGoalGetInvClassFromPerson Name=ErrandGoalGetInvClassFromPerson3
		InvClassName="KrotchyInv"
		TalkToMeTag="Krotchy"
		TriggerOnCompletionTag="DiedEarly"
	End Object
	Begin Object Class=ErrandBase Name=ErrandBase12
		UniqueName="GetKrotchy"
		NameTex="p2misc.map.GetKrotchy_text"
		LocationTex="p2misc.map.GetKrotchy_here"
		LocationX=553
		LocationY=302
		LocationCrossTex="p2misc.map.hint_cross_1"
		LocationCrossX=557
		LocationCrossY=331
		DudeStartComment="DudeDialog.dude_map_getkrotchy"
		DudeWhereComment="DudeDialog.Dude_map_loc2"
		DudeFoundComment="DudeDialog.Dude_map_loc5"
		DudeCompletedComment="DudeDialog.dude_map_missionaccom"
		Goals(0)=ErrandGoalGetPickup'ErrandGoalGetPickup8'
		Goals(1)=ErrandGoalGetInvClassFromPerson'ErrandGoalGetInvClassFromPerson3'
	End Object

	// Get Steaks
	Begin Object Class=ErrandGoalGetInvClassFromPerson Name=ErrandGoalGetInvClassFromPerson1
		InvClassName="SteakInv"
		TalkToMeTag="Fred"
		TriggerOnCompletionTag="SteaksErrand_GotSteaks"
	End Object
	Begin Object Class=ErrandGoalGetPickup Name=ErrandGoalGetPickup4
		PickupTag="SteakPickup"
		HateClass="AW7Slaughterers"
		HateDesTex="p2misc.map.Hate_Group4Name"
		HatePicTex="p2misc.map.Hate_Group4Pic"
		HateComment="DudeDialog.dude_map_hate4"
		TriggerOnCompletionTag="SteaksErrand_StoleSteaks"
	End Object
	Begin Object Class=ErrandBase Name=ErrandBase13
		UniqueName="GetSteaks"
		NameTex="p2misc.map.GetSteaks_text"
		LocationTex="p2misc.map.GetSteaks_here"
		LocationX=749
		LocationY=728
		LocationCrossTex="p2misc.map.hint_cross_4"
		LocationCrossX=746
		LocationCrossY=725
		DudeStartComment="DudeDialog.dude_map_getsteaks"
		DudeWhereComment="DudeDialog.Dude_map_loc4"
		DudeFoundComment="DudeDialog.Dude_map_loc6"
		DudeCompletedComment="DudeDialog.dude_map_anddone"
		Goals(0)=ErrandGoalGetInvClassFromPerson'ErrandGoalGetInvClassFromPerson1'
		Goals(1)=ErrandGoalGetPickup'ErrandGoalGetPickup4'
	End Object

	// Pay Ticket
	Begin Object Class=ErrandGoalGiveInventory Name=ErrandGoalGiveInventory3
		InvClassName="CitationInv"
		GiveToMeTag="Dick"
		TriggerOnCompletionTag="CitationErrand_PaidTicket"
	End Object
	Begin Object Class=ErrandGoalDropOffPickup Name=ErrandGoalDropOffPickup1
		PickupClassName="CitationPickup"
		DropIntoHereTriggerTag="CitationDropOff"
		TriggerOnCompletionTag="CitationErrand_DroppedOffTicket"
	End Object
	Begin Object Class=ErrandBase Name=ErrandBase14
		UniqueName="PayTicket"
		NameTex="p2misc.map.PayTicket_text"
		LocationTex="p2misc.map.PayTicket_here"
		LocationX=677
		LocationY=605
		LocationCrossTex="p2misc.map.hint_cross_4"
		LocationCrossX=681
		LocationCrossY=604
		DudeStartComment="DudeDialog.dude_map_payticket"
		DudeWhereComment="DudeDialog.Dude_map_loc1"
		DudeFoundComment="DudeDialog.Dude_map_loc3"
		DudeCompletedComment="DudeDialog.dude_map_anotherone"
		Goals(0)=ErrandGoalGiveInventory'ErrandGoalGiveInventory3'
		Goals(1)=ErrandGoalDropOffPickup'ErrandGoalDropOffPickup1'
	End Object

	//////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////
	// Friday errands
	//////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////

	// Get Alternator
	Begin Object Class=ErrandGoalGetPickup Name=ErrandGoalGetPickup9
		PickupTag="AlternatorPickup"
		TriggerOnCompletionTag="AlternatorErrand_GotIt"
	End Object
	Begin Object Class=ErrandBase Name=ErrandBase15
		UniqueName="GetAlternator"
		NameTex="p2misc.map.GetAlternator_text"
		LocationTex="p2misc.map.GetAlternator_here"
		LocationX=328
		LocationY=611
		LocationCrossTex="p2misc.map.hint_cross_4"
		LocationCrossX=354
		LocationCrossY=636
		DudeStartComment="DudeDialog.dude_map_getalternator"
		DudeWhereComment="DudeDialog.Dude_map_loc1"
		DudeFoundComment="DudeDialog.Dude_map_loc5"
		DudeCompletedComment="DudeDialog.dude_map_next"
		Goals(0)=ErrandGoalGetPickup'ErrandGoalGetPickup9'
	End Object

	// Pickup Package
	Begin Object Class=ErrandGoalGetPickup Name=ErrandGoalGetPickup11
		PickupTag="ParcelPickup"
		TriggerOnCompletionTag="PackageErrand_GotIt"
		HateClass="AW7ParcelWorkers"
		HateDesTex="p2misc.map.Hate_Group5Name"
		HatePicTex="p2misc.map.Hate_Group5Pic"
		HateComment="DudeDialog.dude_map_hate5"
	End Object
	Begin Object Class=ErrandGoalTalkTo Name=ErrandGoalTalkTo1
		TalkToMeTag="Lucy"
		TriggerOnCompletionTag="PackageErrand_BringItUp"
		HateClass="AW7ParcelWorkers"
		HateDesTex="p2misc.map.Hate_Group5Name"
		HatePicTex="p2misc.map.Hate_Group5Pic"
		HateComment="DudeDialog.dude_map_hate5"
	End Object
	Begin Object Class=ErrandBase Name=ErrandBase16
		UniqueName="PickupPackage"
		NameTex="p2misc.map.BuyStamps_text"
		LocationTex="p2misc.map.BuyStamps_here"
		LocationX=840
		LocationY=693
		LocationCrossTex="p2misc.map.hint_cross_1"
		LocationCrossX=840
		LocationCrossY=693
		DudeStartComment="DudeDialog.dude_map_getpackage"
		DudeWhereComment="DudeDialog.Dude_map_loc2"
		DudeFoundComment="DudeDialog.Dude_map_loc6"
		DudeCompletedComment="DudeDialog.dude_map_anddone"
		Goals(0)=ErrandGoalTalkTo'ErrandGoalTalkTo1'
		Goals(1)=ErrandGoalGetPickup'ErrandGoalGetPickup11'
	End Object

	// Give Present
	Begin Object Class=ErrandGoalGiveInventory Name=ErrandGoalGiveInventory0
		InvClassName="GiftInv"
		GiveToMeTag="UncleDave"
		TriggerOnCompletionTag="UncleDaveErrand_Completed"
	End Object
	Begin Object Class=ErrandGoalKillMe Name=ErrandGoalKillMe0
		KillMeTag="UncleDave"
		TriggerOnCompletionTag="UncleDaveErrand_Completed"
	End Object
	Begin Object Class=ErrandBase Name=ErrandBase17
		UniqueName="GivePresent"
		NameTex="p2misc.map.UncleDavesBday_text"
		LocationTex="p2misc.map.UncleDavesBday_here"
		LocationX=526
		LocationY=57
		LocationCrossTex="p2misc.map.hint_cross_1"
		LocationCrossX=571
		LocationCrossY=64
		DudeStartComment="DudeDialog.dude_map_uncledave"
		DudeWhereComment="DudeDialog.Dude_map_loc4"
		DudeFoundComment="DudeDialog.Dude_map_loc3"
		DudeCompletedComment="DudeDialog.dude_map_tooeasy"
		Goals(0)=ErrandGoalGiveInventory'ErrandGoalGiveInventory0'
		Goals(1)=ErrandGoalKillMe'ErrandGoalKillMe0'
	End Object

	// Visit Clinic
	Begin Object Class=ErrandGoalGetPickup Name=ErrandGoalGetPickup10
		PickupTag="PillsPickup"
		TriggerOnCompletionTag="ClinicErrand_Completed"
	End Object
	Begin Object Class=ErrandBase Name=ErrandBase18
		bInitiallyActive=false	// gets activated during gameplay
		UniqueName="VisitClinic"
		NameTex="p2misc.map.GoToClinic_text"
		LocationTex="p2misc.map.GoToClinic_here"
		LocationX=471
		LocationY=405
		LocationCrossTex="p2misc.map.hint_cross_2"
		LocationCrossX=537
		LocationCrossY=437
		DudeStartComment="DudeDialog.dude_map_clinic"
		DudeWhereComment="DudeDialog.Dude_map_loc1"
		DudeFoundComment="DudeDialog.Dude_map_loc5"
		DudeCompletedComment="DudeDialog.dude_map_next"
		Goals(0)=ErrandGoalGetPickup'ErrandGoalGetPickup10'
	End Object

	//////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////
	// Days are defined here
	//////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////

	// Monday
	Begin Object Class=DayBase Name=DayBase0
        Description="Monday"
		UniqueName="7DAYA"
		ExcludeDays[0]="DEMO"
		Errands(0)=ErrandBase'ErrandBase0'
		Errands(1)=ErrandBase'ErrandBase1'
		Errands(2)=ErrandBase'ErrandBase2'
		Errands(3)=ErrandBase'ErrandBase_DeliverMotherboard'
        MapTex="AW7Tex.Map.aw7_map_day1"
        NewsTex="p2misc.newspaper_day_1"
		DudeNewsComment="DudeDialog.dude_news_monday"
        LoadTex="p2misc_full.loading1"
		DudeStartComment="DudeDialog.dude_map_exit1"

		PlayerInvList(0)=(InvClassName="Inventory.MoneyInv",NeededAmount=20)
		PlayerInvList(1)=(InvClassName="Inventory.MapInv")
		PlayerInvList(2)=(InvClassName="Inventory.HandsWeapon")
		PlayerInvList(3)=(InvClassName="AW7Inventory.KarmaGun")

		TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
		TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
		TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
		TakeFromPlayerList(3)=(InvClassName="Inventory.MilkInv")
		TakeFromPlayerList(4)=(InvClassName="Inventory.PaycheckInv")
		TakeFromPlayerList(5)=(InvClassName="AW7Inventory.MotherboardInv")
	End Object

	// Tuesday
	Begin Object Class=DayBase Name=DayBase1
        Description="Tuesday"
		UniqueName="7DAYB"
		ExcludeDays[0]="DEMO"
		Errands(0)=ErrandBase'ErrandBase3'
		Errands(1)=ErrandBase'ErrandBase4'
		Errands(2)=ErrandBase'ErrandBase5'
		Errands(3)=ErrandBase'ErrandBase6'
        MapTex="AW7Tex.Map.aw7_map_day2"
        NewsTex="p2misc_full.newspaper_day_2"
		DudeNewsComment="DudeDialog.dude_news_tuesday"
        LoadTex="p2misc_full.loading2"
		DudeStartComment="DudeDialog.dude_map_exit2"

		PlayerInvList(0)=(InvClassName="Inventory.LibraryBookInv")
		PlayerInvList(1)=(InvClassName="Inventory.ClipboardWeapon")

		TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
		TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
		TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
		TakeFromPlayerList(3)=(InvClassName="Inventory.ClipboardWeapon")
		TakeFromPlayerList(4)=(InvClassName="Inventory.LibraryBookInv")
		// leave the gary book--you can bribe Krotchy with it
	End Object

	// Wednesday
	Begin Object Class=DayBase Name=DayBase2
        Description="Wednesday"
		UniqueName="7DAYC"
		ExcludeDays[0]="DEMO"
		Errands(0)=ErrandBase'ErrandBase7'
		Errands(1)=ErrandBase'ErrandBase8'
		Errands(2)=ErrandBase'ErrandBase9'
		Errands(3)=ErrandBase'ErrandBase10'
        MapTex="AW7Tex.Map.aw7_map_day3"
        NewsTex="p2misc_full.newspaper_day_3"
		DudeNewsComment="DudeDialog.dude_news_wednesday"
        LoadTex="p2misc_full.loading3"
		DudeStartComment="DudeDialog.dude_map_exit3"

		TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
		TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
		TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
		TakeFromPlayerList(3)=(InvClassName="Inventory.TreeInv")
	End Object

	// Thursday
	Begin Object Class=DayBase Name=DayBase3
		Description="Thursday"
		UniqueName="7DAYD"
		ExcludeDays[0]="DEMO"
        Errands(0)=ErrandBase'ErrandBase11'
		Errands(1)=ErrandBase'ErrandBase12'
		Errands(2)=ErrandBase'ErrandBase13'
		Errands(3)=ErrandBase'ErrandBase14'
        MapTex="AW7Tex.Map.aw7_map_day4"
        NewsTex="p2misc_full.newspaper_day_4"
		DudeNewsComment="DudeDialog.dude_news_thursday"
        LoadTex="p2misc_full.loading4"
		DudeStartComment="DudeDialog.dude_map_exit4"

		PlayerInvList(0)=(InvClassName="Inventory.CitationInv")

		TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
		TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
		TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
		TakeFromPlayerList(3)=(InvClassName="Inventory.KrotchyInv")
		TakeFromPlayerList(4)=(InvClassName="Inventory.SteakInv")
		TakeFromPlayerList(5)=(InvClassName="Inventory.CitationInv")
	End Object

	// Friday
	Begin Object Class=DayBase Name=DayBase4
		Description="Friday"
		UniqueName="7DAYE"
		ExcludeDays[0]="DEMO"
        Errands(0)=ErrandBase'ErrandBase15'
		Errands(1)=ErrandBase'ErrandBase16'
		Errands(2)=ErrandBase'ErrandBase17'
		Errands(3)=ErrandBase'ErrandBase18'
        MapTex="AW7Tex.Map.aw7_map_day5"
        NewsTex="p2misc_full.newspaper_day_5"
		DudeNewsComment="DudeDialog.dude_news_friday"
        LoadTex="p2misc_full.loading5"
		DudeStartComment="DudeDialog.dude_map_exit5"

		PlayerInvList(0)=(InvClassName="Inventory.GiftInv")
		PlayerInvList(1)=(InvClassName="Inventory.GonorrheaAmmoInv")

		TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
		TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
		TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
		TakeFromPlayerList(3)=(InvClassName="Inventory.ParcelInv")
		TakeFromPlayerList(4)=(InvClassName="Inventory.AlternatorInv")
		TakeFromPlayerList(5)=(InvClassName="Inventory.PillsInv")
		TakeFromPlayerList(6)=(InvClassName="Inventory.GonorrheaAmmoInv")
        TakeFromPlayerList(7)=(InvClassName="Inventory.MapInv")
        TakeFromPlayerList(8)=(InvClassName="Inventory.GiftInv")
        // Kill the gary books now if we still have them
        TakeFromPlayerList(9)=(InvClassName="Inventory.GaryBookInv")
	End Object

	// Saturday
    Begin Object Class=DayBase Name=DayBase8
        Description="Saturday"
        UniqueName="DAY_A"
        ExcludeDays(0)="DEMO"
        LoadTex="aw_textures.loading_sat"
        DudeStartComment="DudeDialog.dude_map_exit1"
        Errands(0)=ErrandBase'AWGame.ErrandBase0'
        TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
        TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
        TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
        TakeFromPlayerList(3)=(InvClassName="Inventory.MapInv")
    End Object

    // Sunday
    Begin Object Class=DayBase Name=DayBase9
        Description="Sunday"
        UniqueName="DAY_B"
        ExcludeDays(0)="DEMO"
        LoadTex="aw_textures.loading_sun"
        DudeStartComment="DudeDialog.dude_map_exit1"
        Errands(0)=ErrandBase'AWGame.ErrandBase1'
        TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
        TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
        TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
        TakeFromPlayerList(3)=(InvClassName="Inventory.MapInv")
	End Object

	//////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////
	// the week is defined here
	//////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////

	Days(0)=DayBase'DayBase0'
	Days(1)=DayBase'DayBase1'
	Days(2)=DayBase'DayBase2'
	Days(3)=DayBase'DayBase3'
	Days(4)=DayBase'DayBase4'
	Days(5)=DayBase'DayBase8'
    Days(6)=DayBase'DayBase9'

    IntroURL="AW7_Intro.fuk"
    StartFirstDayURL="AW7_Suburbs-3.fuk"
    StartNextDayURL="AW7_Suburbs-3.fuk"
    FinishedDayURL="AW7_HomeAtNight.fuk"
    WeekendStartURL="AW7_WeekendIntro.fuk"
    JailURL="AW7_Police.fuk#cell"
	MainMenuURL="AW7_Startup.fuk"
    bAllowBehindView=True
    DefaultPlayerName="TheDude"
    GameName="Apocalypse Weekend 7-day Game"
    GameNameShort="7-day"

    DefaultPlayerClassName="AW7Pawns.AW7PostalDude"
    HUDType="AW7Game.AW7HUD"
    PlayerControllerClassName="AW7Game.AW7DudePlayer"
    GameStateClass=class'AW7GameState'
//	MutatorClass="AW7Game.AW7Mutator"
	AW7MutatorClassName="AW7Game.AW7Mutator"

	ApocalypseTex="AW7Tex.Misc.ApocalypseNewspaper"
	FireCorona=Texture'PB_textures.Special.PB_flare_1'
	ApocalypseCatClass=class'DervishCatR'
	ChameleonClass=class'AW7Chameleon'
	GaryHeadClass=class'AW7GaryHead'
	ZombieHeadClass=class'AW7ZombieHead'

	DifficultyNames(0)="Liebermode"
	DifficultyNames(1)="Too Easy"
	DifficultyNames(2)="Very Easy"
	DifficultyNames(3)="Easy"
	DifficultyNames(4)="Remedial"
	DifficultyNames(5)="Average"
	DifficultyNames(6)="Aggressive"
	DifficultyNames(7)="Hard"
	DifficultyNames(8)="Very Hard"
	DifficultyNames(9)="Hestonworld"
	DifficultyNames(10)="Insane-o"
	DifficultyNames(11)="They Hate Me"
	DifficultyNames(12)="Nightmare Mode"
	DifficultyNames(13)="Really Fucking Hard"
}
