class AW7P2GameSingle extends GameSinglePlayer;

var() localized string GameNameShort;

///////////////////////////////////////////////////////////////////////////////
// This function is called before any other scripts (including PreBeginPlay().
///////////////////////////////////////////////////////////////////////////////
event InitGame(out string Options, out string Error)
{
	Super.InitGame(Options, Error);
	MySlotInfoMgr = spawn(class'AW7SlotInfoMgr');
}

///////////////////////////////////////////////////////////////////////////////
// Save game to the specified slot
///////////////////////////////////////////////////////////////////////////////
function SaveGame(int Slot, bool bShowMessage)
	{
	Log(self$" SaveGame(): Slot="$Slot$" bAutoSave="$bDoAutoSave$" bForcedAutoSave="$bForcedAutoSave$" the game state difficulty "$TheGameState.GameDifficulty);

	if (bShowMessage)
		{
		if (Slot == QUICKSAVE_SLOT)
			GetPlayer().ClientMessage(EasySaveMessageString);
		else if (Slot == AUTOSAVE_SLOT && bForcedAutoSave)
			GetPlayer().ClientMessage(ForcedSaveMessageString);
		else if (Slot == AUTOSAVE_SLOT)
			GetPlayer().ClientMessage(AutoSaveMessageString);
		else
			GetPlayer().ClientMessage(NormalSaveMessageString);
		}

	// This slot is now the most recently used slot.  We update this BEFORE the
	// actual save so that if this game is loaded, it will refer to itself as
	// the most recently used.  In other words, whenever a game is loaded, the
	// slot it loaded from becomes the most recently used slot.
	MostRecentGameSlot = Slot;

	// Do the actual save
	ConsoleCommand("SaveGame "$Slot);

	// Save info about this slot
	MySlotInfoMgr.SetInfo(
		Slot,
		GetCurrentDayBase().Description@"-"@Level.Title@"-"@GetDiffName(TheGameState.GameDifficulty)@"-"@GameNameShort,
		GetCurrentDay(),
		Level.Year$"-"$Val2Str(level.Month, 2)$"-"$Val2Str(Level.Day, 2)@":"@Val2Str(Level.Hour, 2)$":"$Val2Str(Level.Minute, 2),
		int(ConsoleCommand("GETGMTIME")));
	}

defaultproperties
{
    GameName="Original Postal 2 game"
    GameNameShort="P2"
}
