///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
class NightmareSpawner extends AWPawnSpawner
	notplaceable;

///////////////////////////////////////////////////////////////////////////////
// 60 seconds until a zombie spawns here!
///////////////////////////////////////////////////////////////////////////////
simulated event PostBeginPlay()
{
	Super.PostBeginPlay();

	SetTimer(10, false);
}

///////////////////////////////////////////////////////////////////////////////
// If our pawn gets destroyed before a zombie spawns, then die
///////////////////////////////////////////////////////////////////////////////
simulated event Tick(float Delta)
{
	if (Owner == None)
		Destroy();
}

///////////////////////////////////////////////////////////////////////////////
// Time's up, spawn a zombie!
///////////////////////////////////////////////////////////////////////////////
simulated event Timer()
{
	local Rotator ThisRot;

    if (AW7Person(Owner) != None)
    	AW7Person(Owner).GotoState('PrepForDissolving');

	SetLocation(Owner.Location);

	ThisRot = Owner.Rotation;
	ThisRot.Pitch = 0;
	ThisRot.Roll = 0;

	SetRotation(ThisRot);
	//spawn(class'ZDissolvePuddle',,,Owner.Location, Owner.Rotation);
	spawn(class'ZFloatRevive',,,Owner.Location);

    DoSpawn();

    if (AW7Person(Owner) == None)
		Pawn(Owner).ChunkUp(200);
}

defaultproperties
{
	SpawnRate = 0
	SpawnClass = class'AW7ZombieRandom'
	MaxSpawned = 1
	bSpawnWhenNotSeen = False
	PawnInitialState = SE_AttackPlayer
	InitbPlayerIsFriend = False
	InitbPlayerIsEnemy = True
}
