///////////////////////////////////////////////////////////////////////////////
// Dusters ammo
///////////////////////////////////////////////////////////////////////////////
class DustersAmmoInv extends InfiniteAmmoInv;

var() array<Sound> PunchSounds;
var() Sound PunchWall;
var() int DamageJab;
var() int DamageUppercut;
var() int DamageDownward;

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function ProcessTraceHit(Weapon W, Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
	local SmokeHitPuff smoke1;
	local DirtClodsMachineGun dirt1;
	local SparkHitMachineGun spark1;
	local Rotator NewRot;
	local vector mom;
	local float UseDamage;

	if ( Other == None )
		return;

	if(Pawn(Other) == None
		&& PeoplePart(Other) == None)
	{
		// randomly orient the splat on the wall (rotate around the normal)
		NewRot = Rotator(-HitNormal);
		NewRot.Roll=(65536*FRand());

		smoke1 = Spawn(class'Fx.SmokeHitPuffMelee',,,HitLocation, Rotator(HitNormal));
		if(FRand()<0.3)
		{
			dirt1 = Spawn(class'Fx.DirtClodsMachineGun',,,HitLocation, Rotator(HitNormal));
		}
		if(FRand()<0.15)
		{
			spark1 = Spawn(class'Fx.SparkHitMachineGun',,,HitLocation, Rotator(HitNormal));
		}
	}


	if ( (Other != self) && (Other != Owner) )
	{
		if (Pawn(Other) == None)
			Instigator.PlaySound(PunchWall, SLOT_None, 1.0,,TransientSoundRadius,GetRandPitch());
		else
			Instigator.PlaySound(PunchSounds[Rand(PunchSounds.Length)], SLOT_None, 1.0,,TransientSoundRadius,GetRandPitch());

		if(!P2Weapon(W).bAltFiring)
		{
			// Left
			if(FPSPawn(Other) == None
				|| HurtingAttacker(FPSPawn(Other)))
			{
            	mom = MomentumHitMag * VRand();
				mom += MomentumHitMag * Y;
				switch (DustersWeapon(W).AnimPlayed)
				{
					case 0: // Left jab
						UseDamage = DamageJab;
						break;

//					case 1: // Left downwards
//						UseDamage = DamageDownward;
//						mom.z *= -0.2;
//						break;

					case 1: // Left uppercut
						UseDamage = DamageUppercut;
						mom.z *= 0.2;
						break;
				}
				Other.TakeDamage(UseDamage, Pawn(Owner), HitLocation, mom, DamageTypeInflicted);
			}
		}
		else
		{
			// Right
			if(FPSPawn(Other) == None
				|| HurtingAttacker(FPSPawn(Other)))
			{
            	mom = MomentumHitMag * VRand();
				mom -= MomentumHitMag * Y;

				switch (DustersWeapon(W).AnimPlayed)
				{
					case 0: // Right jab
						UseDamage = DamageJab;
						break;

					case 1: // Right uppercut
						UseDamage = DamageUppercut;
						mom.z *= 0.2;
						break;
				}

				Other.TakeDamage(UseDamage, Pawn(Owner), HitLocation, mom, DamageTypeInflicted);
			}
		}
	}
}

defaultproperties
{
//	DamageAmount=10
//	DamageAmountMP=25
	DamageJab=5
	DamageUppercut=10
	DamageDownward=20
	bInstantHit=true
	Texture=Texture'AW7EDTex.Icons.hud_Dusters'
	DamageTypeInflicted=class'AW7FX.DustersDamage'
	MomentumHitMag=30000
	TransientSoundRadius=80
	PunchSounds(0)=Sound'AW7Sounds.Dusters.Punch1'
	PunchSounds(1)=Sound'AW7Sounds.Dusters.Punch2'
	PunchSounds(2)=Sound'AW7Sounds.Dusters.Punch3'
	PunchSounds(3)=Sound'AW7Sounds.Dusters.Punch4'
	PunchWall=Sound'AW7Sounds.Dusters.Punch_Wall2'
}
