///////////////////////////////////////////////////////////////////////////////
// BatonWeapon
// Copyright 2002 Running With Scissors, Inc.  All Rights Reserved.
//
// Police baton weapon (first and third person).
//
// Low damage bludgeoning attacks.
//
// Enhanced mode: explodes heads with one hit.
//
///////////////////////////////////////////////////////////////////////////////

class DustersWeapon extends ShovelWeapon;

var int AnimPlayed;
var int ThirdAnimUsed;

simulated function PlayFiring()
{
	//randomly pick the animation to use (left)
	AnimPlayed = rand(2);
	switch (AnimPlayed)
	{
       case 0:
            PlayAnim('left_jab', WeaponSpeedShoot1 + (WeaponSpeedShoot1Rand*FRand()));
            break;
//       case 1:
//            PlayAnim('left_downwards', WeaponSpeedShoot1 + (WeaponSpeedShoot1Rand*FRand()));
//            break;
       case 1:
            PlayAnim('left_uppercut', WeaponSpeedShoot1 + (WeaponSpeedShoot1Rand*FRand()));
            break;
	}
	ThirdAnimUsed = AnimPlayed;

	if(bShowHint1)
	{
		bShowHint1=false;
		UpdateHudHints();
	}
}

simulated function PlayAltFiring()
{
	//randomly pick the animation to use (right)
	AnimPlayed = rand(2);
	switch (AnimPlayed)
	{
       case 0:
            PlayAnim('right_jab', WeaponSpeedShoot2 + (WeaponSpeedShoot2Rand*FRand()));
            break;
       case 1:
            PlayAnim('right_uppercut', WeaponSpeedShoot2 + (WeaponSpeedShoot2Rand*FRand()));
            break;
	}
	ThirdAnimUsed = AnimPlayed + 2;

	if(!bShowHint1)
		TurnOffHint();
}

///////////////////////////////////////////////////////////////////////////////
// Set first person hands texture
///////////////////////////////////////////////////////////////////////////////
simulated function ChangeHandTexture(Texture NewHandsTexture, Texture DefHandsTexture, Texture NewFootTexture)
{
	Skins[1] = NewHandsTexture;
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////
defaultproperties
{
//	bNoHudReticle=true
	bUsesAltFire=true
	ItemName="Dusters"
	AmmoName=class'DustersAmmoInv'
	PickupClass=class'DustersPickup'
	AttachmentClass=class'DustersAttachment'

//	Mesh=Mesh'FP_Weapons.FP_Dude_Baton'
	Mesh=SkeletalMesh'AW7_EDWeapons.ED_Dusters_NEW'
//	Skins[0]=Texture'WeaponSkins.Dude_Hands'
	Skins[0]=Shader'AW7EDTex.Weapons.Dustersfinal'
	Skins[1]=Texture'MP_FPArms.LS_arms.LS_hands_dude'

	FirstPersonMeshSuffix="ED_Dusters_NEW"

	WeaponsPackageStr="AW7_EDWeapons."

	PlayerViewOffset=(X=1.0000,Y=0.000000,Z=-2.0000)

	bMeleeWeapon=true
	ShotMarkerMade=None
	BulletHitMarkerMade=None
    bDrawMuzzleFlash=false

	holdstyle=WEAPONHOLDSTYLE_Melee
	switchstyle=WEAPONHOLDSTYLE_Single
	firingstyle=WEAPONHOLDSTYLE_Melee

	//shakemag=350.000000
	//shaketime=0.200000
	//shakevert=(X=0.0,Y=0.0,Z=4.00000)
	FireOffset=(X=2.000000,Y=0.00000,Z=-1.00000)
	ShakeOffsetMag=(X=0,Y=6,Z=0)
	ShakeOffsetRate=(X=1000.0,Y=1000.0,Z=1000.0)
	ShakeOffsetTime=3.0
	ShakeRotMag=(X=30.0,Y=250.0,Z=30.0)
	ShakeRotRate=(X=10000.0,Y=10000.0,Z=10000.0)
	ShakeRotTime=3.0

	//FireSound=Sound'WeaponSounds.baton_fire1'
	//AltFireSound=Sound'WeaponSounds.baton_fire2'
	CombatRating=1.0
	AIRating=0.1
	AutoSwitchPriority=1
	InventoryGroup=1
	GroupOffset=5
	BobDamping=0.975000
	ReloadCount=0
	TraceAccuracy=0.1
	ViolenceRank=1
	bBumpStartsFight=false
	AI_BurstCountExtra=2
	AI_BurstCountMin=1
	AI_BurstTime=1.0

	WeaponSpeedIdle	   = 0.3
	WeaponSpeedHolster = 1.5
	WeaponSpeedLoad    = 1.25
	WeaponSpeedReload  = 1.0
	WeaponSpeedShoot1  = 0.9
	WeaponSpeedShoot1Rand=0.2
	WeaponSpeedShoot2  = 0.9
	AimError=200

	HudHint1="Press Fire (Left Mouse Button) for a left punch."
	HudHint2="Alt Fire (Right Mouse Button) for a right punch."
	bCanThrowMP=false

	PlayerMeleeDist=100
	NPCMeleeDist=90.0
	MaxRange=90
	RecognitionDist=600

	WeaponSpeedShoot1=1.00
	WeaponSpeedShoot2=1.00
	WeaponSpeedShoot1Rand=0.100000
	WeaponSpeedShoot2Rand=0.100000
}
