class WardrobeInv extends ClothesInv;

var array<class> WardSkins;
var bool bShortSleeves;

state Activated
{
	///////////////////////////////////////////////////////////////////////////////
	// Setup a swap of our current clothes out for these
	///////////////////////////////////////////////////////////////////////////////
	function StartChangeClothes()
	{
		local P2Player p2p;
		local P2Pawn CheckPawn;
		local class OurClass;

		if(Owner != None)
		{
			p2p = P2Player(Pawn(Owner).Controller);

			if(p2p != None)
			{
				// See if we can change our clothes
				OurClass=WardSkins[Rand(WardSkins.Length)];
				if(p2p.CheckForChangeClothes(class<Inventory>(OurClass)))
				{
					TurnOffHints();	// When you use it, turn off the hints

					p2p.SayTime = 0;
					ChangeWorked(p2p);
					WaitTime = p2p.SayTime;
					GotoState('Activated', 'DoChange');
					return;
				}
			}
		}
		GotoState('Activated', 'Failed');
	}
}

defaultproperties
{
	Icon=Texture'AW7Tex.Icons.hud_wardrobe'
	PickupClass=class'WardrobePickup'
	Hint1="Use this to change clothes at random!"
	Hint2="Try it out in front of a mirror and see"
	Hint3="what you can get!"

	WardSkins[0]=class'wHomoClothes'
	WardSkins[1]=class'wBandClothes'
	WardSkins[2]=class'wBookClothes'
	WardSkins[3]=class'wBumClothes'
	WardSkins[4]=class'wZealotClothes'
	WardSkins[5]=class'wFanaticClothes'
	WardSkins[6]=class'wMcDClothes'
	WardSkins[7]=class'wHippyClothes'
	WardSkins[8]=class'wGangsterClothes'
	WardSkins[9]=class'wMallworkerClothes'
	WardSkins[10]=class'wMeatClothes'
	WardSkins[11]=class'wRedneckClothes'
	WardSkins[12]=class'wRWSClothes'
	WardSkins[13]=class'wScientistClothes'
	WardSkins[14]=class'wButcherClothes'
	WardSkins[15]=class'wPriestClothes'
}
