//=============================================================================
// MaDBaseyInv.
// Created on: 04/05/2005
// Written by Eduard Klemens
// Mail to: madjackal_x@hotmail.com.
//  2005, MaD Inc. All Rights Reserved.
//=============================================================================
class MaDBaseyInv extends InfiniteAmmoInv;

#exec OBJ LOAD FILE=MaDModsSounds.uax
#exec OBJ LOAD FILE=MaDModsTex.utx

var Sound BatonHit;
var Sound BatonHitWall;

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function ProcessTraceHit(Weapon W, Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
	local SmokeHitPuff smoke1;
	local DirtClodsMachineGun dirt1;
	local SparkHitMachineGun spark1;
	local MaDMaceSmash mms;
	local Rotator NewRot;
	local vector mom;
	local float UseDamage;

	if ( Other == None )
		return;

	if ( Other.bStatic)//Other.bWorldGeometry )
	{
	      // randomly orient the splat on the wall (rotate around the normal)
		NewRot = Rotator(-HitNormal);
		NewRot.Roll=(65536*FRand());

		smoke1 = Spawn(class'Fx.SmokeHitPuffMelee',,,HitLocation, Rotator(HitNormal));
		if(FRand()<0.3)
		{
			dirt1 = Spawn(class'Fx.DirtClodsMachineGun',,,HitLocation, Rotator(HitNormal));
		}
		if(FRand()<0.15)
		{
			spark1 = Spawn(class'Fx.SparkHitMachineGun',,,HitLocation, Rotator(HitNormal));
		}
    }

	if ( (Other != self) && (Other != Owner) )
	{
		Instigator.PlaySound(BatonHitWall, SLOT_None, 1.0,,TransientSoundRadius,GetRandPitch());

		if(Level.Game != None
			&& Level.Game.bIsSinglePlayer)
			UseDamage = DamageAmount;
		else
			UseDamage = DamageAmountMP;
			mms = Spawn(class'AW7MaDInventory.MaDMaceSmash',,,HitLocation, Rotator(HitNormal));

		if(!P2Weapon(W).bAltFiring)
		{
			if(FPSPawn(Other) == None
				|| HurtingAttacker(FPSPawn(Other)))
				Other.TakeDamage(UseDamage, Pawn(Owner), HitLocation, -MomentumHitMag*Y  + MomentumHitMag*vect(0, 0, 1.0)*(FRand() + 0.2), DamageTypeInflicted);
				Instigator.PlaySound(BatonHit, SLOT_None, 1.0,,TransientSoundRadius,GetRandPitch());
				Instigator.PlayOwnedSound(BatonHit, SLOT_None, 1.0,,TransientSoundRadius,GetRandPitch());
		}
		else
		{
			if(FPSPawn(Other) == None
				|| HurtingAttacker(FPSPawn(Other)))
			{
				mom = VRand();
				mom.z=0;
				mom.x*=0.1;
				mom.y*=0.1;

				Other.TakeDamage(UseDamage, Pawn(Owner), HitLocation, -MomentumHitMag*Z + MomentumHitMag*mom, DamageTypeInflicted);
				Instigator.PlaySound(BatonHit, SLOT_None, 1.0,,TransientSoundRadius,GetRandPitch());
				Instigator.PlayOwnedSound(BatonHit, SLOT_None, 1.0,,TransientSoundRadius,GetRandPitch());
			}
		}
		
		If ((Other.IsA('Pawn') || Other.IsA('PeoplePart')) && BloodWeapon(W) != None)
			BloodWeapon(W).DrewBlood();
	}
}

defaultproperties
{
     BatonHit=Sound'MaDModsSounds.MaDBaseyHit'
     BatonHitWall=Sound'MaDModsSounds.MaDBaseyWallhit'
     DamageAmount=75.000000
     MomentumHitMag=60000.000000
     DamageTypeInflicted=Class'AW7MaDInventory.MaDBaseyDamage'
     DamageAmountMP=75.000000
     bInstantHit=True
     Texture=Texture'MaDModsTex.Icon_Weapon_MaDBasey'
     TransientSoundRadius=80.000000
}
