//=============================================================================
// MaDBeerInv.
// Created on: 02/25/2005
// Written by Eduard Klemens
// Mail to: madjackal_x@hotmail.com.
//  2005, MaD Inc. All Rights Reserved.
//=============================================================================
class MaDBeerInv extends P2PowerupInv;

#exec OBJ LOAD FILE=MaDModsSounds.uax
#exec OBJ LOAD FILE=MaDModsTex.utx

var Sound ActivateSound;	// sound for drinkin'!
var float HealingPct;	// Percentage of how much health you add
var bool bWorked;
var bool bCantThrow;

///////////////////////////////////////////////////////////////////////////////
// Generally used by QuickHealth player key to determine which powerup he
// should use next when healing himself.
///////////////////////////////////////////////////////////////////////////////
simulated function float RateHealingPower()
{
	local P2MocapPawn CheckPawn;

	CheckPawn = P2MocapPawn(Owner);

	if(CheckPawn != None)
		return (CheckPawn.HealthMax*HealingPct/100);
	else
		return 0;
}

///////////////////////////////////////////////////////////////////////////////
// Active state: this inventory item is armed and ready to rock!
///////////////////////////////////////////////////////////////////////////////
state Activated
{
	ignores Activate;

	///////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////
	function bool DrinkIt()
	{
		local P2Pawn CheckPawn;

		CheckPawn = P2Pawn(Owner);

		// if tainted == 1, we'll divide 2, otherwise, the normal amount will be granted.
		if(CheckPawn.AddHealthPct(HealingPct/(1 + Tainted), Tainted, , , , true))
		{
			TurnOffHints();	// When you use it, turn off the hints
			Owner.PlaySound(ActivateSound);

			Amount -= 1;	// Don't check just yet if we're used up
							// but do remove this one from the pile.
			return true;
		}
		return false;
	}

Begin:
	DrinkIt();
	// Check now if we're out of these.
	if(Amount <= 0)
		UsedUp();

	GotoState('');
}

function Timer()
{
	bCantThrow = false;
}

///////////////////////////////////////////////////////////////////////////////
// Toss this item out.
///////////////////////////////////////////////////////////////////////////////
function DropFrom(vector StartLocation)
{
	if (!bCantThrow || MpPawn(Owner).Health <= 0)
	{
		bCantThrow=true;
		SetTimer(0.5, false);
		Super.DropFrom(StartLocation);
	}
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////

defaultproperties
{
     ActivateSound=Sound'MaDModsSounds.MaDDrinkin'
     HealingPct=25.000000
     Hint1="Just what your"
     Hint2="liver needs.  "
	HealingString="You drunk M@DJ@cK@L's finest Beer!"
     InventoryGroup=125
     PickupClass=Class'AW7MaDInventory.MaDBeerPickup'
     Icon=Texture'MaDModsTex.Icon_Inv_MaDBeer'
}
