//=============================================================================
// MaDColtBulletAmmoInv.
// Created on: 03/25/2005
// Written by Eduard Klemens
// Mail to: madjackal_x@hotmail.com.
//  2005, MaD Inc. All Rights Reserved.
//=============================================================================
class MaDColtBulletAmmoInv extends P2AmmoInv;

#exec OBJ LOAD FILE=MaDModsTex.utx

const FLESH_HIT_MAX	=	4;

var Sound FleshHit[FLESH_HIT_MAX];
var float FleshRad;

///////////////////////////////////////////////////////////////////////////////
// Process a trace hitting something
///////////////////////////////////////////////////////////////////////////////
function ProcessTraceHit(Weapon W, Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
	local Rotator NewRot;

	// reduce the ammo
	UseAmmoForShot();

	if ( Other == None )
		return;

	if ( Other.bStatic)//Other.bWorldGeometry )
		{
		spawn(class'PistolBulletHitPack',W.Owner, ,HitLocation, Rotator(HitNormal));
		}
	else
	{
		Other.TakeDamage(DamageAmount, Pawn(Owner), HitLocation, MomentumHitMag*X, DamageTypeInflicted);

		if((Pawn(Other) != None
				&& Other != Owner)
			|| PeoplePart(Other) != None
			|| CowheadProjectile(Other) != None)
		{
			Other.PlaySound(FleshHit[Rand(ArrayCount(FleshHit))],SLOT_Pain,,,FleshRad,GetRandPitch());
		}
		else // anything else--make a spark hit
		{
			spawn(class'BulletSparkPack',W.Owner, ,HitLocation, Rotator(HitNormal));
		}
	}
}


///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////

defaultproperties
{
     FleshHit(0)=Sound'WeaponSounds.bullet_hitflesh1'
     FleshHit(1)=Sound'WeaponSounds.bullet_hitflesh2'
     FleshHit(2)=Sound'WeaponSounds.bullet_hitflesh3'
     FleshHit(3)=Sound'WeaponSounds.bullet_hitflesh4'
     FleshRad=200.000000
     DamageAmount=25.000000
     MomentumHitMag=30000.000000
     DamageTypeInflicted=Class'BaseFX.RifleDamage'
     MaxAmmo=24
     bLeadTarget=True
     bInstantHit=True
     WarnTargetPct=0.200000
     RefireRate=0.990000
     PickupClass=Class'AW7MaDInventory.MaDColtAmmoPickup'
     Texture=Texture'MaDColtTextures.Icon_Weapon_MaDColt'
}
