//=============================================================================
// MaDPickup.
// Modifyed on: 03/25/2005
// Written by Kamek
// Modifyed by Eduard Klemens
// Kamek@cox.net
// Mail to: madjackal_x@hotmail.com.
//  2005, MaD Inc. All Rights Reserved.
//=============================================================================
class MaDPickup extends OwnedPickup
	/*/*config(MaDMods)*/*/;

const DSResolution = 0.01;
const DESTROY_DELAY			=	100; // make sure it's a while and that people have had time to grab it (1 minute)

// If your custom pickup has a limited number of uses or a countdown-style use like the radar, you MUST
// define OurAmountToAdd in defaultproperties. Otherwise the player will only get one.
var /*config*/ int OurAmountToAdd;
var localized string AlreadyHeldMessage;

// We don't want bots having these, at all
/*function float BotDesireability( pawn Bot )
{
	return 0;
}*/

// Bots want these, a lot, but incompatible pickups go away
function float BotDesireability( pawn Bot )
{
	return MaxDesireability;
}

function Inventory FindInv(Pawn P, class DesiredClass)
{
	local Inventory Inv;

	for (Inv=P.Inventory; Inv!=None; Inv=Inv.Inventory)
		if (ClassIsChildOf(Inv.Class, DesiredClass))
			return Inv;

	return None;
}

state Pickup
{
	// Here we have to check to see if the player already has an mad pickup.
	// Players may only hold one mad pickup at a time.
	function Touch(actor Other)
	{
		local inventory Inv, Next;
//		local MaDDrugsInv CheckA;
		local P2Player p2p;

		if (MpPawn(Other) != None)
		{
			// Check their inventory for an mad pickup.
			if (FindInv(Pawn(Other), class'MaDSpeedInv') != None)
			{
				// They already have one, so tell them and don't let them grab the pickup
				/*p2p = P2Player(MpPawn(Other).Controller);
				if (p2p != None)
					p2p.ClientMessage(AlreadyHeldMessage);*/
				return;
			}
//			if (P2Player(MpPawn(Other).Controller) == None) // Don't allow bots to get these, it causes problems
//				return;
		}
		Super.Touch(Other);
	}

}

defaultproperties
{
     OurAmountToAdd=1
     AlreadyHeldMessage="You can only have one of these at a time."
     MaxDesireability=-1.000000
     InventoryType=Class'AW7MaDInventory.MaDInv'
     PickupMessage="You picked up an M@D powerup."
     DrawType=DT_StaticMesh
     StaticMesh=StaticMesh'stuff.stuff1.Gift'
     DrawScale=0.800000
}
