//=============================================================================
// MaDSMPBulletAmmoInv.
// Created on: 03/25/2005
// Written by Eduard Klemens
// Mail to: madjackal_x@hotmail.com.
//  2005, MaD Inc. All Rights Reserved.
//=============================================================================
class MaDSMPBulletAmmoInv extends P2AmmoInv;

#exec OBJ LOAD FILE=MaDModsStatics.usx
#exec OBJ LOAD FILE=MaDModsTex.utx

const FLESH_HIT_MAX	=	4;

var Sound FleshHit[FLESH_HIT_MAX];
var float FleshRad;

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function ProcessTraceHit(Weapon W, Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
	local Rotator NewRot;

	if ( Other == None )
		return;

	if(Other.bStatic)
	{
		spawn(class'MachinegunBulletHitPack',W.Owner, ,HitLocation, Rotator(HitNormal));
	}
	else
	{
		Other.TakeDamage(DamageAmount, Pawn(Owner), HitLocation, MomentumHitMag*X, DamageTypeInflicted);

		if((Pawn(Other) != None && Other != Owner)
			|| PeoplePart(Other) != None
			|| CowheadProjectile(Other) != None)
		{
			Other.PlaySound(FleshHit[Rand(ArrayCount(FleshHit))],SLOT_Pain,,,FleshRad,GetRandPitch());
		}
		else // anything else--make a spark hit
		{
			spawn(class'BulletSparkPack',W.Owner, ,HitLocation, Rotator(HitNormal));
		}
	}
}

defaultproperties
{
     FleshHit(0)=Sound'WeaponSounds.bullet_hitflesh1'
     FleshHit(1)=Sound'WeaponSounds.bullet_hitflesh2'
     FleshHit(2)=Sound'WeaponSounds.bullet_hitflesh3'
     FleshHit(3)=Sound'WeaponSounds.bullet_hitflesh4'
     FleshRad=200.000000
     DamageAmount=5.000000
     MomentumHitMag=50000.000000
     DamageTypeInflicted=Class'BaseFX.MachineGunDamage'
     DamageAmountMP=5.000000
     MaxAmmoMP=250
     MaxAmmo=500
     bLeadTarget=True
     bInstantHit=True
     WarnTargetPct=0.200000
     RefireRate=0.990000
     PickupClass=Class'AW7MaDInventory.MaDSMPAmmoPickup'
     Texture=Texture'MaDModsTex.Icon_Weapon_MaDSMP'
}
