//=============================================================================
// MaDSyringeWeirdness.
// Modifyed on: 03/25/2005
// Written by Kamek
// Modifyed by Eduard Klemens
// Kamek@cox.net
// Mail to: madjackal_x@hotmail.com.
//  2005, MaD Inc. All Rights Reserved.
//=============================================================================
class MaDSyringeWeirdness extends Actor
	/*config(MaDMods)*/;

#exec OBJ LOAD FILE=MaDModsSounds.uax

var /*config*/ float Lifetime; // how long we last
var MpPawn OurTarget; // pawn of the target
var P2Player OurTargetController; // controller of the target
var MaDEmitter OurWeirdness;
var bool bBot;

var sound WeirdoSound; // strange sound to play when we activate

replication
{
	// stuff we send to the client
	reliable if (Role == ROLE_Authority)
		StartWeirdness, StopWeirdness, OurTargetController;
}

// a lot of weirdness functions require executing code client-side
simulated function StartWeirdness();
simulated function StopWeirdness();

// start the weirdness and tell them
function pwned(MpPawn Other)
{
	OurTarget=Other;
	if (P2Player(Other.Controller) != None)
	{
		OurTargetController=P2Player(Other.Controller);
	}
	else
		bBot=true;
	OurWeirdness=spawn(class'MaDSyringeCloud', OurTarget);
	OurTarget.AttachToBone(OurWeirdness, 'MALE01 spine1');
	OurTarget.PlaySound(WeirdoSound, SLOT_MISC);
	StartWeirdness();
	SetTimer(Lifetime, false);
}

// Check to make sure our guy's still alive
event Tick(float DeltaTime)
{
	if (OurTarget == None || (OurTargetController == None && !bBot))
	{
		StopWeirdness();
		OurWeirdness.GoAway();
		Destroy();
	}
	Super.Tick(DeltaTime);
}

// time's up, end the weirdness
event Timer()
{
	OurWeirdness.GoAway();
	StopWeirdness();
	Destroy();
}

defaultproperties
{
     Lifetime=15.000000
     WeirdoSound=Sound'MaDModsSounds.MaDSWeird'
     DrawType=DT_None
}
