//=============================================================================
// MaDWeedInv.
// Created on: 02/25/2005
// Written by Eduard Klemens
// Mail to: madjackal_x@hotmail.com.
//  2005, MaD Inc. All Rights Reserved.
//=============================================================================
class MaDWeedInv extends P2PowerupInv;

#exec OBJ LOAD FILE=MaDModsSounds.uax
#exec OBJ LOAD FILE=MaDModsTex.utx

var Sound ActivateSound;
var Sound InhaleSound;
var Sound ExhaleSound;
var Sound ComentSound;	// sounds for smokin'!
var float WeedMaxHealthPercentage;
var bool bWorked;
var vector SmokeColor;
var bool bCantThrow;

/*
replication
{
	reliable if(Role==ROLE_Authority)
		BlowingSmoke;
}
*/

///////////////////////////////////////////////////////////////////////////////
// Generally used by QuickHealth player key to determine which powerup he
// should use next when healing himself.
///////////////////////////////////////////////////////////////////////////////
simulated function float RateHealingPower()
{
	local P2MocapPawn CheckPawn;

	CheckPawn = P2MocapPawn(Owner);

	if(CheckPawn != None)
		return (CheckPawn.HealthMax*WeedMaxHealthPercentage);
	else
		return 0;
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
simulated function BlowingSmoke()
{
	local P2MocapPawn CheckPawn;
	local P2Player p2p;

	CheckPawn = P2MocapPawn(Owner);
	p2p = P2Player(CheckPawn.Controller);

	p2p.BlowSmoke(SmokeColor);
}

///////////////////////////////////////////////////////////////////////////////
// Active state: this inventory item is armed and ready to rock!
///////////////////////////////////////////////////////////////////////////////
state Activated
{
	ignores Activate;

	///////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////
	function bool SmokeIt()
	{
		local P2MocapPawn CheckPawn;
		local float HealingAmount;	// How much health you add

		CheckPawn = P2MocapPawn(Owner);

		TurnOffHints();	// When you use it, turn off the hints

		// calc how much we need to get to our max health goal
		HealingAmount = (CheckPawn.HealthMax * WeedMaxHealthPercentage) - CheckPawn.Health;

		if(CheckPawn.AddHealth(HealingAmount,,,true, true))
		{
			Amount -= 1;	// Don't check just yet if we're used up
							// but do remove this one from the pile.
			return true;
		}
		return false;
	}

	///////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////
	function CommentOnIt()
	{
		local P2MocapPawn CheckPawn;

		CheckPawn = P2MocapPawn(Owner);
		if(P2Player(CheckPawn.Controller) != None)
			P2Player(CheckPawn.Controller).CommentOnCrackUse();
	}

Begin:
	Owner.PlaySound(ActivateSound);
	Sleep(Owner.GetSoundDuration(ActivateSound));
	Owner.PlaySound(InhaleSound);
	Sleep(Owner.GetSoundDuration(InhaleSound));
	Owner.PlaySound(ExhaleSound);
	Sleep(Owner.GetSoundDuration(ExhaleSound));
	BlowingSmoke();
	SmokeIt();
//	Owner.PlaySound(ComentSound);
//	Sleep(Owner.GetSoundDuration(ComentSound));
	CommentOnIt();
	// Check now if we're out of these.
	if(Amount <= 0)
		UsedUp();

	GotoState('');
}

function Timer()
{
	bCantThrow = false;
}

///////////////////////////////////////////////////////////////////////////////
// Toss this item out.
///////////////////////////////////////////////////////////////////////////////
function DropFrom(vector StartLocation)
{
	if (!bCantThrow || MpPawn(Owner).Health <= 0)
	{
		bCantThrow=true;
		SetTimer(0.5, false);
		Super.DropFrom(StartLocation);
	}
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////

defaultproperties
{
     ActivateSound=Sound'MaDModsSounds.MaDSmokin'
     InhaleSound=Sound'MaDModsSounds.MaDInhale'
     ExhaleSound=Sound'MaDModsSounds.MaDExhale'
     ComentSound=Sound'WMaleDialog.wm_kickass'
     WeedMaxHealthPercentage=1.500000
     smokecolor=(X=255.000000,Y=255.000000,Z=255.000000)
     Hint1="Press Enter to smoke M@DJ@cK@L's Weed."
     Hint2="Warning: Causes M@D health boosts"
     Hint3="and good feelings."
     HealingString="You smoked M@DJ@cK@L's Weed Bong."
//     ExpireMessage="M@DJ@cK@L say: A Bong a day, keeps the Doc away!"
     InventoryGroup=102
     PickupClass=Class'AW7MaDInventory.MaDWeedPickup'
     Icon=Texture'MaDModsTex.Icon_Inv_MaDWeed'
}
