//=============================================================================
// MaDZyclonExplosion.
// Created on: 05/04/2005
// Written by Eduard Klemens
// Mail to: madjackal_x@hotmail.com.
//  2005, MaD Inc. All Rights Reserved.
//=============================================================================
class MaDZyclonExplosion extends P2Explosion;

var bool bGroundHit;
const	FIRE_INDEX	=	0;
const	DIRT_INDEX	=	1;
const	DUST_INDEX	=	2;
const	BLOOD_INDEX	=	3;
var Sound  GrenadeExplodeAir;
var Sound  GrenadeExplodeGround;

replication
{
	// server sends this to client if enough bandwidth
	unreliable if(Role==ROLE_Authority)
		ClientMakeBlood, ClientMakeAir;
}

///////////////////////////////////////////////////////////////////////////////
// Perhaps do something special if you hit a wall
///////////////////////////////////////////////////////////////////////////////
function CheckForHitType(Actor Other)
{
	local vector endpt;

	// Make bloody explosion
	if(Pawn(Other) != None)
	{
		ClientMakeBlood();
	}
	else
	{
		endpt = Location;
		endpt.z -= CollisionRadius;
		if(FastTrace(endpt, Location))
		// We *didn't* hit ground, so turn *off* dirt effects
		{
			ClientMakeAir();
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
simulated function ClientMakeAir()
{
	Emitters[DIRT_INDEX].Disabled=true;
	Emitters[DUST_INDEX].Disabled=true;
	bGroundHit=false;
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
simulated function ClientMakeBlood()
{
	Emitters[DIRT_INDEX].Disabled=true;
	Emitters[DUST_INDEX].Disabled=true;
	// Only if we allow blood
	if(class'P2Player'.static.BloodMode())
		Emitters[BLOOD_INDEX].Disabled=false;
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
auto state Exploding
{
Begin:
	if(bGroundHit)
 		PlaySound(GrenadeExplodeGround,,1.0,,,,true);
	else
		PlaySound(GrenadeExplodeAir,,1.0,,,,true);
	Sleep(DelayToHurtTime);

	CheckHurtRadius(ExplosionDamage, ExplosionRadius, MyDamageType, ExplosionMag, Location);
	NotifyPawns();
}

defaultproperties
{
     bGroundHit=True
     ExplosionMag=5000.000000
     ExplosionDamage=300.000000
     MyDamageType=Class'AW7MaDInventory.MaDZyclonExplodedDamage'
     Emitters(0)=SpriteEmitter'FX.SpriteEmitter146'
     Emitters(1)=SpriteEmitter'FX.SpriteEmitter27'
     Emitters(2)=SpriteEmitter'FX.SpriteEmitter29'
     Emitters(3)=SpriteEmitter'FX.SpriteEmitter148'
     AutoDestroy=True
     LifeSpan=5.000000
     TransientSoundRadius=600.000000
}
