//=============================================================================
// Copyright 2002 Running With Scissors, Inc.  All Rights Reserved.
//=============================================================================
class AW7Gary extends AW7ScaredGary;

///////////////////////////////////////////////////////////////////////////////
// Record pawn dead, if player killed them
///////////////////////////////////////////////////////////////////////////////
function Died(Controller Killer, class<DamageType> damageType, vector HitLocation)
{
	if(P2GameInfoSingle(Level.Game) != None
		&& P2GameInfoSingle(Level.Game).TheGameState != None
		&& AW7GameState(P2GameInfoSingle(Level.Game).TheGameState) != None
		&& Killer != None
		&& Killer.bIsPlayer)
	{
		// Record the pawn as an innocent, if we don't hate the player.
		if (bInnocent)
			AW7GameState(P2GameInfoSingle(Level.Game).TheGameState).InnocentsKilled++;
	}

	Super.Died(Killer, damageType, HitLocation);
}

defaultproperties
	{
	Skins[0]=Texture'ChameleonSkins.Special.Gary'
	DialogClass=class'AW7DialogGary'

	bPlayerIsEnemy=false
	bRandomizeHeadScale=false
	bPersistent=true
	bHasRef=false
	bKeepForMovie=true
	bCanTeleportWithPlayer=false
	AnimGroupUsed=-1

	ControllerClass=class'AW7GaryController'
	BaseEquipment[0]=(weaponclass=class'Inventory.MachinegunWeapon')
	BaseEquipment[1]=(weaponclass=class'Inventory.GrenadeWeapon')
	BaseEquipment[2]=(weaponclass=class'Inventory.GaryBookInv')
	WeapChangeDist=800
	DamageMult=2.0
	Psychic=1.0
	Champ=0.9
	Cajones=1.0
	Temper=1.0
	Glaucoma=0.5
	Twitch=1.0
	TwitchFar=3.5
	Rat=0.1
	Compassion=0.0
	WarnPeople=0.0
	Conscience=0.0
	Beg=0.0
	PainThreshold=1.0
	Reactivity=0.5
	Confidence=1.0
	Rebel=0.0
	Curiosity=0.5
	Patience=0.5
	WillDodge=0.5
	WillKneel=0.05
	WillUseCover=0.9
	Talkative=0.2
	Stomach=1.0
	VoicePitch=1.0
	TalkWhileFighting=0.5
	TalkBeforeFighting=1.0
	HealthMax=550.0
	bStartupRandomization=false
	TakesShotgunHeadShot=	0.05
	TakesRifleHeadShot=		0.15
	TakesShovelHeadShot=	0.15
	TakesOnFireDamage=		0.25
	TakesAnthraxDamage=		0.25
	TakesShockerDamage=		0.1
	TakesPistolHeadShot=    0.25
	TakesMachinegunDamage=  0.3
	TakesChemDamage=		0.1
	}
