// AW7Police
// Base class for all police characters in AW7.
// AW7 police are a lot stronger than normal Postal 2 police.
class AW7Police extends AW7AuthorityFigure
	notplaceable
	Abstract;

///////////////////////////////////////////////////////////////////////////////
// Decide on a prize for a quick kill
///////////////////////////////////////////////////////////////////////////////
function PickQuickKillPrize(int KillIndex)
{
	local class<Inventory> invclass;
	local Inventory newone;

//	log(self@"PickQuickKillPrize");

	switch(KillIndex)
	{
		case 0:
			invclass = class'DonutInv';
		break;
		case 1:
			invclass = class'MoneyInv';
		break;
		case 2:
			invclass = class'FastFoodInv';
		break;
		case 3:
			invclass = class'MaDBeerInv';
		break;
		case 4:
			invclass = class'CrackInv';
		break;
		case 5:
			invclass = class'MaDWeedInv';
		break;
		case 6:
			invclass = class'CopClothesInv';
		break;
	}
//	log(self@"picked inventory type"@InvClass);
	newone = spawn(invclass, self);
//	log(self@"tossing inventory"@newone);
	TossThisInventory(vector(Rotation), newone);
}

///////////////////////////////////////////////////////////////////////////////
// Set dialog class
///////////////////////////////////////////////////////////////////////////////
function SetDialogClass()
{
	if (bIsFemale)
		DialogClass=class'AW7Dialog.AW7DialogFemaleCop';
	else
		DialogClass=class'AW7Dialog.AW7DialogMaleCop';
}

defaultproperties
{
	// AW7 Properties
	CopRadioClass=class'AW7Inventory.CopRadioInv'
//	HealthMax=250.00
//	DamageMult=3.0
	ControllerClass=Class'AW7Pawns.AW7PoliceController'
	// AW properties
	BlockMeleeFreq=0.85
	TakesSledgeDamage=1.00
	TakesMacheteDamage=0.75
	TakesScytheDamage=1.00
	TakesDervishDamage=0.75
	TakesZombieSmashDamage=1.00
	// Normal properties
	CloseWeaponIndex=2
	FarWeaponIndex=3
	bHasRadio=True
	boltons(0)=(Bone="cop_badge",StaticMesh=StaticMesh'boltons.cop_badge')
	Psychic=0.200000
	Champ=0.500000
	Cajones=0.600000
	Temper=0.120000
	Glaucoma=0.800000
	Rat=1.000000
	Compassion=1.000000
	WarnPeople=1.000000
	Conscience=1.000000
	PainThreshold=1.000000
	Reactivity=0.400000
	Rebel=1.000000
	WillDodge=0.300000
	WillUseCover=0.600000
	TalkWhileFighting=0.000000
	TakesShotgunHeadShot=0.200000
	TakesShockerDamage=0.700000
	TalkBeforeFighting=0.000000
	Fitness=0.550000
	BaseEquipment(0)=(WeaponClass=Class'Inventory.HandCuffsWeapon')
	BaseEquipment(1)=(WeaponClass=Class'Inventory.BatonWeapon')
	BaseEquipment(2)=(WeaponClass=Class'Inventory.PistolWeapon')
	ViolenceRankTolerance=0
	HealthMax=140.000000
	Gang="Police"
	DonutLove=0.750000
	bFriendWithAuthority=True
	FriendDamageThreshold=0.000000
	AttackRange=(Min=256.000000,Max=4096.000000)
	HeadClass=class'AW7Head'
}
