//=============================================================================
// PublisherGuard
// Copyright 2004 Running With Scissors, Inc.  All Rights Reserved.
//
//=============================================================================
class AW7PublisherGuard extends AW7Person
	placeable;

///////////////////////////////////////////////////////////////////////////////
// Adds all the required equipment and picks out the urethra.
// Do this here so we access to the inventory package for specific things
// like HandsWeapon and UrethraWeapon.
// Publisher guards get random arsenals
///////////////////////////////////////////////////////////////////////////////
function AddDefaultInventory()
{
	local int i;

	// Only let this be called once
	if (!bGotDefaultInventory)
	{
		i = rand(4);
		switch(i)
		{
			case 0:
				CreateInventoryByClass(class'ShotgunWeapon');
				break;
			case 1:
				CreateInventoryByClass(class'PistolWeapon');
				break;
			case 2:
				CreateInventoryByClass(class'MachinegunWeapon');
				break;
			case 3:
				CreateInventoryByClass(class'MaDSMPWeapon');
				break;
		}
	}
	
	Super.AddDefaultInventory();
}

defaultproperties
{
     BlockMeleeFreq=0.950000
     ChameleonSkins(0)="End"
     ChameleonMeshPkgs(0)="Characters"
     Psychic=0.400000
     Champ=0.700000
     Cajones=0.700000
     Temper=0.350000
     Glaucoma=0.450000
     Rat=1.000000
     Compassion=0.000000
     WarnPeople=0.000000
     Conscience=0.000000
     Beg=0.000000
     PainThreshold=1.000000
     Reactivity=0.750000
     Rebel=1.000000
     WillDodge=0.400000
     WillKneel=0.200000
     WillUseCover=0.800000
     Stomach=1.000000
     Armor=100.000000
     ArmorMax=100.000000
     TalkWhileFighting=0.100000
     TakesShotgunHeadShot=0.250000
     TakesRifleHeadShot=0.300000
     TakesShovelHeadShot=0.350000
     TakesOnFireDamage=0.400000
     TakesAnthraxDamage=0.500000
     TakesShockerDamage=0.100000
     TalkBeforeFighting=0.100000
     Fitness=0.900000
     bAuthorityFigure=True
     dialogclass=Class'BasePeople.DialogMaleMilitary'
     ViolenceRankTolerance=0
     HealthMax=130.000000
     bPlayerIsEnemy=True
     Gang="PublisherGuard"
     AttackRange=(Min=512.000000,Max=4096.000000)
     ControllerClass=Class'AW7MilitaryController'
     Mesh=SkeletalMesh'Characters.Avg_M_SS_Pants'
     Skins(0)=Texture'AW_Characters.Special.Bullfish_Security'
}
