//=============================================================================
// SWAT
// Copyright 2001 Running With Scissors, Inc.  All Rights Reserved.
//
// Base class for all SWAT characters.
//
//=============================================================================
class AW7SWAT extends AW7Military;

///////////////////////////////////////////////////////////////////////////////
// Record pawn dead, if player killed them
///////////////////////////////////////////////////////////////////////////////
function Died(Controller Killer, class<DamageType> damageType, vector HitLocation)
{
	// Skip counting SWAT kills as military kills
	Super(AW7AuthorityFigure).Died(Killer, damageType, HitLocation);
}

simulated event PostBeginPlay()
{
	Super.PostBeginPlay();
	
	if (Role == ROLE_Authority)
		TakesSledgeDamage = 1.0;
}

defaultproperties
{
	// SWAT don't have the military helmets, so they can be sledged just like anybody else
	TakesSledgeDamage=1.0

	HeadSkin=Texture'ChamelHeadSkins.Special.Robber'
	HeadMesh=SkeletalMesh'heads.Masked'
	bRandomizeHeadScale=False
	boltons(0)=(Bone="NODE_Parent",StaticMesh=StaticMesh'boltons.Swat_Goggles',bAttachToHead=True)
	boltons(1)=(bInactive=True)
	ChameleonSkins(0)="ChameleonSkins.MW__071__Big_M_LS_Pants"
	ChameleonSkins(1)="End"
	Psychic=0.400000
	Champ=0.700000
	Cajones=0.700000
	Temper=0.350000
	Glaucoma=0.450000
	Rat=1.000000
	Compassion=0.000000
	WarnPeople=0.000000
	Conscience=0.000000
	Beg=0.000000
	PainThreshold=1.000000
	Reactivity=0.750000
	Rebel=1.000000
	WillDodge=0.400000
	WillKneel=0.200000
	WillUseCover=0.800000
	Stomach=1.000000
	Armor=100.000000
	ArmorMax=100.000000
	TalkWhileFighting=0.100000
	TakesShotgunHeadShot=0.250000
	TakesRifleHeadShot=0.300000
	TakesShovelHeadShot=0.350000
	TakesOnFireDamage=0.400000
	TakesAnthraxDamage=0.500000
	TakesShockerDamage=0.100000
	TalkBeforeFighting=0.100000
	Fitness=0.900000
	dialogclass=Class'BasePeople.DialogMaleMilitary'
	BaseEquipment(0)=(WeaponClass=Class'Inventory.MachineGunWeapon')
	BaseEquipment(1)=(WeaponClass=Class'Inventory.PistolWeapon')
	ViolenceRankTolerance=0
	HealthMax=225.000000
	Gang="SWAT"
	AttackRange=(Min=512.000000,Max=4096.000000)
	ControllerClass=Class'AWPawns.AWMilitaryController'
	Mesh=SkeletalMesh'Characters.Big_M_LS_Pants'
	Skins(0)=Texture'ChameleonSkins.SWAT.XX__159__Big_M_LS_Pants'
	GutsEmitterClass1=Class'AW7FX.TorsoGutsIntestine'
	GutsEmitterClass2=Class'AW7FX.TorsoGutsOrgans'
	HeadClass=class'AW7Head'
	LimbClass=class'AW7Limb'
}
