///////////////////////////////////////////////////////////////////////////////
// AWMainMenu.uc
// Copyright 2003 Running With Scissors, Inc.  All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////
// This class describes the main menu details and processes main menu events.
///////////////////////////////////////////////////////////////////////////////
class AW7MainMenu extends MenuMain;

var bool bIsDemo;

var ShellMenuChoice NewP2GameChoice;
var string NewP2GameText;

///////////////////////////////////////////////////////////////////////////////
// Create menu contents
///////////////////////////////////////////////////////////////////////////////
function CreateMenuContents()
{
	Super(BaseMenuBig).CreateMenuContents();
	AddTitleBitmap(TitleTexture);

	NewChoice     = AddChoice(NewGameText,		"",									ItemFont, ItemAlign);
	//NewP2GameChoice = AddChoice(NewP2GameText,	"",									ItemFont, ItemAlign);
	LoadChoice    = AddChoice(LoadGameText,		OptionUnavailableInDemoHelpText,	ItemFont, ItemAlign);
	LoadChoice.bActive = !GetLevel().IsDemoBuild();
	//MultiChoice   = AddChoice(MultiText,		"",									ItemFont, ItemAlign);
	OptionsChoice = AddChoice(OptionsText,		"",									ItemFont, ItemAlign);
	ExitChoice    = AddChoice(ExitGameText,		"",									ItemFont, ItemAlign);

	// Reset this value. When MenuDifficultyPatch starts up, it's the only one that needs it
	// and it will set it when necessary.
	ShellRootWindow(Root).bFixSave=false;
}

///////////////////////////////////////////////////////////////////////////////
// Handle notifications from controls
///////////////////////////////////////////////////////////////////////////////
function Notify(UWindowDialogControl C, byte E)
	{
	local bool bHandled;

	switch(E)
		{
		case DE_Click:
			if (C != None)
				switch (C)
					{
					case OptionsChoice:
						GoToMenu(class'AW7MenuOptions');
						bHandled = true;
						break;
					case NewChoice:
						// Start new game
						SetSingleplayer();
						ShellRootWindow(Root).bVerifiedPicked=false;
						if (!bIsDemo)
							GotoMenu(class'AW7MenuStart');
						else
							GotoMenu(class'MenuImageKeys');
						bHandled = true;
						break;
					case NewP2GameChoice:
						// Start new game
						SetSingleplayer();
						ShellRootWindow(Root).bVerifiedPicked=false;
						if (!bIsDemo)
							GotoMenu(class'AW7MenuOldStart');
						else
							GotoMenu(class'MenuImageKeys');
						bHandled = true;
						break;
					}
			break;
		}

	if (!bHandled)
		Super.Notify(C, E);
	}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////

defaultproperties
{
//	DudeClassStr="AW7Pawns.AW7PostalDude"
	TitleTexture=Texture'AW7Tex.Misc.AW7Menu'
//	MenuOptionsClass=Class'AW7MenuOptions'
//	bIsDemo=True
	NewGameText="New Game"
	NewP2GameText="New P2/AW Game"
}
