///////////////////////////////////////////////////////////////////////////////
// MenuControlsEditActions.uc
// Copyright 2002 Running With Scissors, Inc.  All Rights Reserved.
//
//	02/01/03 JMI	Moved all control definitions into the base class.  The idea
//					is to be able to know all the mappable controls from all the
//					menus.  GetControls() still returns the controls this menu
//					will edit.
//
// 12/17/02 NPF Renamed from Character to Actions menu
//
///////////////////////////////////////////////////////////////////////////////
class AW7MenuControlsEditActions extends MenuControlsEditActions;

var Control BulletControl;

///////////////////////////////////////////////////////////////////////////////
// Get the controls to be edited.  Tells the base class what to edit.
///////////////////////////////////////////////////////////////////////////////
function array<Control> GetControls()
{
	local array<Control> ThisArr;
	local P2GameInfoSingle ThisGame;

	ThisArr = aActionControls;

	ThisGame = GetGameSingle();
	if (AW7GameInfo(ThisGame) != None && AW7GameInfo(ThisGame).AllEnabled())
	{
		aActionControls.Insert(aActionControls.Length, 1);
		aActionControls[aActionControls.Length - 1] = BulletControl;
	}

	return aActionControls;
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////

defaultproperties
{
     Defaults(68)=(alias="Bullet",Key="Alt",Cat="New")
     BulletControl=(strAlias="Bullet",strLabel="Bullet Time")
}
