///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
class AW7MenuOldStart extends AWMenuStart;

var string StartGameOrig;
var string StartGameP2;

var UWindowCheckBox EnhancedCheckbox;
var ShellMenuChoice StartOrig;
var ShellMenuChoice StartP2;

var localized string EnhancedText;
var localized string StartOrigText;
var localized string StartP2Text;

var localized string EnhancedHelp;
var localized string StartOrigHelp;
var localized string StartP2Help;

///////////////////////////////////////////////////////////////////////////////
// Create menu contents
///////////////////////////////////////////////////////////////////////////////
function CreateMenuContents()
	{
	Super(ShellMenuCW).CreateMenuContents();

	AddTitle(TitleText, F_FancyXL, TA_Left);

	ItemFont = F_FancyL;
	DifficultyCombo = AddComboBox(DifficultyText, DifficultyHelp, ItemFont);
	DifficultyCombo.List.MaxVisible = ArrayCount(P2GameInfoSingle(GetPlayerOwner().Level.Game).DifficultyNames);

	if (GetGameSingle().FinallyOver())
	{
		EnhancedCheckbox = AddCheckbox(EnhancedText, EnhancedHelp, ItemFont);
		EnhancedCheckbox.SetValue(False);
	}

	StartOrig =		AddChoice(StartOrigText,	StartOrigHelp,		ItemFont,	TA_Left);
	StartP2 =		AddChoice(StartP2Text,		StartP2Help,		ItemFont,	TA_Left);

	BackChoice =	AddChoice(BackText,   	"",				ItemFont,	TA_Left, true);

	LoadValues();
	}

///////////////////////////////////////////////////////////////////////////////
// Allows for use of enhanced mode
///////////////////////////////////////////////////////////////////////////////
function StartGame2(bool bEnhanced)
{
	local P2Player p2p;
	local P2GameInfoSingle usegame;

	usegame = GetGameSingle();
	p2p = usegame.GetPlayer();
	P2RootWindow(Root).StartingGame();

	// Stop any active SceneManager so player will have a pawn
	usegame.StopSceneManagers();

	usegame.PrepIniStartVals();
	usegame.TheGameState.bEGameStart = bEnhanced;

	// Get the difficulty ready for this game state.
	usegame.SetupDifficultyOnce();

	// Get rid of any things in his inventory before a new game starts
	P2Pawn(p2p.pawn).DestroyAllInventory();

	// Game doesn't actually start until player is sent to first day,
	// which *should* happen at the end of the intro sequence.
	usegame.TheGameState.bChangeDayPostTravel = true;
	usegame.TheGameState.NextDay = 0;
	// Actually start the game with the first level
	usegame.SendPlayerTo(p2p, StartGameURL);
}

///////////////////////////////////////////////////////////////////////////////
// Handle notifications from controls
///////////////////////////////////////////////////////////////////////////////
function Notify(UWindowDialogControl C, byte E)
	{
	local int val;

	Super(ShellMenuCW).Notify(C, E);
	switch(E)
		{
		case DE_Change:
			switch (C)
			{
				case DifficultyCombo:
					DiffChanged(bUpdate);
					break;
			}
			break;
		case DE_Click:
			switch (C)
			{
				case BackChoice:
					GoBack();
					break;
				case StartOrig:
					StartGameURL = StartGameOrig;
					GetGameSingle().TheGameState.CurrentDay = 6; // fool the loading screen into thinking it's Saturday
					StartGame2(EnhancedCheckbox.GetValue());
					ShellRootWindow(Root).bLaunchedMultiplayer = false;
					break;
				case StartP2:
					StartGameURL = StartGameP2;
					StartGame2(EnhancedCheckbox.GetValue());
					ShellRootWindow(Root).bLaunchedMultiplayer = false;
					break;
			}
			break;
		}
}

defaultproperties
{
	MenuWidth=375.000000
	MenuHeight=400.000000
	TitleSpacingY=30.000000
	ItemSpacingY = 10

	StartGameOrig="MovieIntro.fuk?Game=AW7Game.AW7AWGameSingle"
	StartGameP2="Intro.fuk?Game=AW7Game.AW7P2GameSingle"
	StartOrigHelp="Play original AW game (no AWP)"
	StartP2Help="Play the original Postal 2 (no AW or AWP)"
	StartOrigText="Original AW Start"
	StartP2Text="Original Postal 2 Start"
	EnhancedText="Enhanced Game"
	EnhancedHelp="Play the Enhanced Game"
}
