///////////////////////////////////////////////////////////////////////////////
// AWRootWindow.uc
// Copyright 2003 Running With Scissors, Inc.  All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////
class AW7RootWindow extends AWRootWindow;

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
var const int KeyConfigVersion;
var config int AW7Version;

var() class<P2GameInfoSingle> OrigAWGameClass;
var() class<P2GameInfoSingle> OrigP2GameClass;
var() class<P2GameInfoSingle> AW7GameClass;

var bool bEnhancedMode;
var string StartGameURL;

///////////////////////////////////////////////////////////////////////////////
// Called after this object has been created
///////////////////////////////////////////////////////////////////////////////
event Initialized()
{
	Super.Initialized();

	OrigAWGameClass.Default.MainMenuURL = AW7GameClass.Default.MainMenuURL;
	OrigP2GameClass.Default.MainMenuURL = AW7GameClass.Default.MainMenuURL;

/*
	if (AW7Version != KeyConfigVersion)
	{
		// Set up INI file on first INI creation.
		log(self@"initializing AW7 INI settings...");

		GetPlayerOwner().ConsoleCommand("set Engine DefaultGame AW7Game.AW7GameInfo");
		GetPlayerOwner().ConsoleCommand("set System SavePath ../AW7Save");
		AW7Version = KeyConfigVersion;
		SaveConfig();

		GetPlayerOwner().Level.ServerTravel("?Game=AW7Game.AW7GameInfo", false);
	}
*/
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////

defaultproperties
{
	OrigAWGameClass=class'AWWrapGame.AWGameSPFinal'
	OrigP2GameClass=class'GameTypes.GameSinglePlayer'
	AW7GameClass=class'AW7Game.AW7GameInfo'

	MenuMainClass=Class'AW7Shell.AW7MainMenu'
	MenuGameClass=Class'AW7Shell.AW7MenuGame'
	StartupMapName="AW7_Startup"
	KeyConfigVersion=100
}
